#include "InterceptAnalyzer.h"

#include "Analyzer.h"


#include "../basic/Timer.h"
#include "../intentions/skills/Skills.h"
#include "../worldmodel/Situation.h"
#include "../worldmodel/WorldModelInterface.h"

InterceptAnalyzer::InterceptAnalyzer() {
  simStepOfLastCalc = 0;
  goalieInterceptRunBehaviour = Skills::STANDARD_BEHAVIOR;

// Achtung ! folgendes ist fr fiese Timing-Flle ntig
  myStepsToBall = 0;
  ourGoalieStepsToBall = 0;
  nearestEnemyStepsToBall = 0;
  nearestTeammateStepsToBall = 0;
  secondNearestTeammateStepsToBall = 0;
  calculatedSteps = 0; 
}



void InterceptAnalyzer::calculateValues(){
  INFO( Log::ANY,  10,  idString() , globalLog->infoStream
    << "InterceptAnalyzer::calculateValues started at " << globalTimer->getAgentTime() << endl);

//int duration = globalTimer->getAgentTime();

//cout << "\n*******************************************\n";
//cout << "InterceptAnalyzer::calculateValues in " << globalWorldModel->simStep() << endl;

  Situation situation = globalWorldModel->situation();
  situation.removePlayerWithId( globalWorldModel->id() ); 
  const ModelledBall& ball = globalWorldModel->ball();
/*
cout << "  -----------------------------------------------------\n";
cout << "  the Ball: " << ball << endl;
cout << "  -----------------------------------------------------\n";
cout << "  mySelf: " << globalWorldModel->player() << endl;
cout << "  -----------------------------------------------------\n";
*/

// nearestEnemyPlayer ***************************************************************************************************************
  int nearestEnemyPlayerIndex = situation.indexOfNearestPlayer(THEIR_TEAM_ID);
  if( nearestEnemyPlayerIndex != UNDEF_INT) {
    calculateMinInterceptTarget( situation.playerWithIndex( nearestEnemyPlayerIndex ),
                                 situation.playerWithIndex( nearestEnemyPlayerIndex ).kickRange() );
  }
  else{
    calculatedSteps = 1000;
    calculatedTarget = ball.pos() + Vector( 45 * ball.speed().length() / globalConf->ballSpeedMax, ball.speed().angle(), POLAR, RADIAN );
  }
  nearestEnemyStepsToBall = calculatedSteps;
  nearestEnemyInterceptPosition = calculatedTarget;
// **********************************************************************************************************************************

// goalie ***************************************************************************************************************************
  bool foundGoalie = NO;
  int index = 0;
  const Situation& s = globalWorldModel->situation();
  for(index=0; index < s.playerCount(); ++index){
    const ModelledPlayer& p = s.playerWithIndex(index);
    if( (p.isGoalie() == YES) && (p.team() == OUR_TEAM_ID) ){
      foundGoalie = YES;
      break;
    }
  }
  if( foundGoalie == YES ) {
	  // es wird noch geprft ob er den Ball erst hinter der Linie erreichen kann und ggf. das Target angepat
	  const ModelledPlayer& goalie = s.playerWithIndex(index);

	  calculateGoalieInterceptTarget( goalie, globalConf->catchAreaLength - 0.3 );
	  ourGoalieStepsToBall = calculatedSteps;
	  ourGoalieInterceptPosition = calculatedTarget;

		if( ourGoalieInterceptPosition.x() < -1.0 * globalWorldModel->field().fieldLength() / 2.0 )
		{
		  double borderIntersectY = ball.pos().y() 
		                            + ( ball.speed().y() / ball.speed().x() )
		                               * ( globalWorldModel->field().ourGoal().x() - ball.pos().x() );
		  // geht der Ball am Tor vorbei, laufen wir zum Pfosten

		  if( borderIntersectY < globalWorldModel->field().ourGoalBottom().y() ) {
		    borderIntersectY = globalWorldModel->field().ourGoalBottom().y();
		  }
		  else if( borderIntersectY > globalWorldModel->field().ourGoalTop().y() ){
		    borderIntersectY = globalWorldModel->field().ourGoalTop().y();
		  }

		  ourGoalieInterceptPosition = Vector( globalWorldModel->field().ourGoal().x(), borderIntersectY );
		
		  globalSkills->resetSituation();
		  int calcPlanSize = ( globalSkills->gotoRegion( ourGoalieInterceptPosition, globalConf->catchAreaLength - 0.2, globalConf->interceptBallStaminaLimit, goalieInterceptRunBehaviour ).size() );
		  ourGoalieStepsToBall = max( 0, calcPlanSize );
	  }
  }
  else {
    ourGoalieStepsToBall = 1000;
    ourGoalieInterceptPosition = Vector(-52.5, 0.0);
  }  
//cout << globalWorldModel->simStep() << " resulting InterceptTarget after= " << ourGoalieStepsToBall << " steps is ";
//cout << ourGoalieInterceptPosition << endl;
// **********************************************************************************************************************************

// myself ***************************************************************************************************************************
  if( globalWorldModel->player().isGoalie() == NO ) {
	  calculateOptInterceptTarget( globalWorldModel->player(), globalWorldModel->player().kickRange() - 0.2 );
	  myStepsToBall = calculatedSteps;
	  myInterceptPosition = calculatedTarget;
	}
	else {
	  myStepsToBall = ourGoalieStepsToBall;
	  myInterceptPosition = ourGoalieInterceptPosition;
  }
// **********************************************************************************************************************************


// nearestTeammate ******************************************************************************************************************
  int nearestTeammateIndex = situation.indexOfNearestPlayer(OUR_TEAM_ID);
  if( nearestTeammateIndex != UNDEF_INT) {
      calculateMinInterceptTarget( situation.playerWithIndex( nearestTeammateIndex ),
                                   situation.playerWithIndex( nearestTeammateIndex ).kickRange() - 0.2 );
  }
  else{
    calculatedSteps = 1000;
    calculatedTarget = ball.pos() + Vector( 45 * ball.speed().length() / globalConf->ballSpeedMax, ball.speed().angle(), POLAR, RADIAN );
  }
  nearestTeammateStepsToBall = calculatedSteps;
  nearestTeammateInterceptPosition = calculatedTarget;
// **********************************************************************************************************************************

// 2ndNearestTeammate
  int secondNearestTeammateIndex = situation.indexOfSecondNearestTeammate();
  if( secondNearestTeammateIndex != UNDEF_INT) {
      calculateMinInterceptTarget( situation.playerWithIndex( secondNearestTeammateIndex ),
                                   situation.playerWithIndex( secondNearestTeammateIndex ).kickRange() - 0.2 );
  }
  else{
    calculatedSteps = 1000;
    calculatedTarget = ball.pos() + Vector( 45 * ball.speed().length() / globalConf->ballSpeedMax, ball.speed().angle(), POLAR, RADIAN );
  }
  secondNearestTeammateStepsToBall = calculatedSteps;
  secondNearestTeammateInterceptPosition = calculatedTarget;
// **********************************************************************************************************************************


  INFO( Log::ANY,  10,  idString() , globalLog->infoStream
    << "InterceptAnalyzer::calculateValues ended at " << globalTimer->getAgentTime() << endl );
/*
cout << "\nmyStepsToBall = " << myStepsToBall << endl;
cout << "ourGoalieStepsToBall = " << ourGoalieStepsToBall << endl;
cout << "nearestEnemyStepsToBall = " << nearestEnemyStepsToBall << "  ( " << situation.index2Id(nearestEnemyPlayerIndex) << " )\n";
cout << "nearestTeammateStepsToBall = " << nearestTeammateStepsToBall << "  ( " << situation.index2Id(nearestTeammateIndex) << " )\n";
cout << "2ndNearestTeammateStepsToBall = " << secondNearestTeammateStepsToBall << "  ( " << situation.index2Id(secondNearestTeammateIndex) << " )\n";
cout << "end of InterceptAnalyzer::calculateValues()\n";
cout << "*******************************************\n";
*/
  simStepOfLastCalc = globalWorldModel->simStep();

//cerr << "InterceptAnalyzer : " << (globalTimer->getAgentTime() - duration) << "  ms\n";
}



void InterceptAnalyzer::calculateMinInterceptTarget(const ModelledPlayer& player, double targetRadius) {
//cout << "InterceptAnalyzer::calculateMinInterceptTarget()\n";

  if( targetRadius < 0.0 ) {
	targetRadius = player.kickRange() - 0.2 ;
  }
  // Schritt 1: Minimalabschtzung der Laufzeit bis zum Intercept
  //   unter Ausnutzung der BallDist und PlayerDist-Tables
  const ModelledBall& ball = globalWorldModel->ball();

 Situation s = Situation( globalWorldModel->simStep() );
 ModelledPlayer hackPlayer = player;
 hackPlayer.setId( globalWorldModel->id() );
 s.setPlayer( hackPlayer );
 s.setBall( ball );

 if( ball.speed().length() < 0.05 ){
    calculatedTarget = ball.pos();
	  globalSkills->resetSituation(s);
    calculatedSteps = (globalSkills->gotoRegion( calculatedTarget, targetRadius, globalConf->interceptBallStaminaLimit )).size();
 }
  
  else { // Ball bewegt sich

    Vector tempTarget;
    int i = 0;

	  double distBetweenPlayerAndBall;
	  Vector vi;
	  double playerVelocityOffset;
	  Vector speed = player.speed();
	  // geschtzte Anzahl der Steps bis zum Target
	  for( i=0; i<= 50; ++i ) {
	    tempTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(i), ball.speed().angle(), POLAR, RADIAN);
  	  vi = tempTarget - player.pos();
	    distBetweenPlayerAndBall = vi.length();
	    vi.normalize();
	    playerVelocityOffset = rint(10 * speed * vi);
	
	    if( distBetweenPlayerAndBall <= player.getMaxDistAfterSteps(i,playerVelocityOffset) + targetRadius ) {
	      break;
	    }
	  }


//cout << " 1.)   i = " << i << endl;

	  // Schritt 2: Verschlechtern des Targets falls PlayerGeschwindigkeit nicht in Zielrichtung zeigt
	  double tempTargetDeviation = fabs( deviationBetween( (tempTarget - player.pos()).angle(), speed.angle() ) ) ;
	  if( tempTargetDeviation > radFromDegree(20) ){
	    ++i;
	    speed = player.decay() * speed;
	  }
	  if( tempTargetDeviation > radFromDegree(60) ){
	    ++i;
	    speed = player.decay() * speed;
	  }
    speed = player.speed();
//cout << "      2.Schritt: i = " << i << "    j = " << j  << endl;


	  // Schritt 3: auf das tempTarget den goToRegionSkill anschmeissen
	  //   die Abweichung in den Steps analysieren und Target entsprechend nachfhren

	  int exactSteps = 1000;
	  int counter = 0;
	  while( (i<50) && (abs(exactSteps - i) != 0) && (counter < 3) ) {
	    ++counter;
	    globalSkills->resetSituation( s );
	    tempTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(i), ball.speed().angle(), POLAR, RADIAN);
	    double playerVelocityInTempTarget = player.getMaxDistAfterSteps(i+1) - player.getMaxDistAfterSteps(i);
	    vector<Action> plan = globalSkills->gotoRegion( tempTarget, targetRadius, globalConf->interceptBallStaminaLimit );
	    exactSteps = plan.size();
	    double oldDist = ( tempTarget - player.pos()).length();
	    double newDist = ( ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(min(exactSteps,50)), ball.speed().angle(), POLAR, RADIAN) - player.pos() ).length();
	    int additionalSteps = (int) ceil( (newDist - oldDist) / playerVelocityInTempTarget );
	    additionalSteps = max( additionalSteps, 0 );
      if( (additionalSteps != 0) &&  (i != exactSteps + ceil( additionalSteps/2 ) ) ) {
	      i = exactSteps + (int) ceil( additionalSteps/2 ) ;
	    }
	    else {
	      i = exactSteps;
	    }
	  }
//cout << "resulting InterceptSteps = " << i << endl;
//cout << "resulting MinInterceptTarget = " << tempTarget << endl;

    calculatedSteps = i;
    calculatedTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(calculatedSteps), ball.speed().angle(), POLAR, RADIAN);
  }// end else (Ball bewegt sich)

//cout << "leave InterceptAnalyzer::calculateMinInterceptTarget()\n";
}



void InterceptAnalyzer::calculateGoalieInterceptTarget(const ModelledPlayer& player, double targetRadius) {

//cout << "calculateGoalieInterceptTarget()\n";

  if( targetRadius < 0.0 ) {
		targetRadius = globalConf->catchAreaLength - 0.5;
  }

  const ModelledBall& ball = globalWorldModel->ball();

  Situation s = Situation( globalWorldModel->simStep() );
  ModelledPlayer hackPlayer = player;
  hackPlayer.setId( globalWorldModel->id() );
  s.setPlayer( hackPlayer );
  s.setBall( ball );

  if( ball.speed().length() < 0.05 ){
    calculatedTarget = ball.pos();
	  globalSkills->resetSituation(s);
    calculatedSteps = (globalSkills->gotoRegion( calculatedTarget, targetRadius, globalConf->interceptBallStaminaLimit )).size();
  }

  else { // Ball bewegt sich

	  int i; // Anfang der InterceptArea
	  int j; // Ende der InterceptArea
	  Vector iTempTarget;
	  Vector jTempTarget;

	// Lot berechnen
	double m = (   ( ball.pos().y() - player.pos().y() ) * ball.speed().y()
					  + ( ball.pos().x() - player.pos().x() ) * ball.speed().x() )
					/ ( ball.speed().x() * ball.speed().x() + ball.speed().y() * ball.speed().y() );
	Vector Lot = Vector( ball.pos().x() + m * ball.speed().x(),
											 ball.pos().y() + m * ball.speed().y(),
											 CARTESIAN );
//  globalSkills->resetSituation();
//	int lotSteps = (globalSkills->gotoRegion( Lot, 0.2, globalConf->interceptBallStaminaLimit )).size();


  // Schritt 1: Minimalabschtzung der Laufzeit bis zum Intercept
  // geschtzte Anzahl der Steps bis zum Target
	  double distBetweenPlayerAndBall;
	  Vector vi;
	  Vector speed = player.speed();
	  double playerVelocityInITempTargetDirection;
	  double playerVelocityOffset;
	
	  for( i=0; i<= 50; ++i ) {
	    iTempTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(i), ball.speed().angle(), POLAR, RADIAN);
  	  vi = iTempTarget - player.pos();
	    distBetweenPlayerAndBall = vi.length();
	    vi.normalize();
	    playerVelocityOffset = rint(10 * speed * vi);
	
	    if( distBetweenPlayerAndBall <= player.getMaxDistAfterSteps(i,playerVelocityOffset) + targetRadius ) {
	      break;
	    }
	  }
	  for( j=i+1; j<= 50; ++j ) {
	    jTempTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(j), ball.speed().angle(), POLAR, RADIAN);
	    distBetweenPlayerAndBall = ( jTempTarget - player.pos() ).length();
	    if( (distBetweenPlayerAndBall > player.getMaxDistAfterSteps(j) + targetRadius)
	        || ( fabs(jTempTarget.x()) > globalWorldModel->field().enemyGoal().x())
	        || ( fabs(jTempTarget.y()) > 0.5 * globalWorldModel->field().fieldWidth() )
	        || (nearestEnemyStepsToBall + 1 < j )
			    || (j > i+2) ) {
	      --j;
	      break;
	    }
	  }
	  j = max( i, j );

//cout << "      1.Schritt: i = " << i << "    j = " << j  << endl;
	
	  // Schritt 2: Verschlechtern des Targets falls PlayerGeschwindigkeit
	  //   nicht in Zielrichtung zeigt
	  double iTempTargetDeviation = fabs( deviationBetween( (iTempTarget - player.pos()).angle(), speed.angle() ) ) ;
	  if( iTempTargetDeviation > radFromDegree(20) ){
	    ++i;
	    speed = player.decay() * speed;
	  }
	  if( iTempTargetDeviation > radFromDegree(60) ){
	    ++i;
	    speed = player.decay() * speed;
	  }
    speed = player.speed();
//cout << "      2.Schritt: i = " << i << "    j = " << j  << endl;

	  // Schritt 3: auf das tempTarget den goToRegionSkill anschmeissen
	  //   die Abweichung in den Steps analysieren und Target entsprechend nachfhren
	  //   nicht fr j! sonst wird j succesive nach i verschoben

	  --i;
	
	  int exactSteps = 1000;
	  int counter = 0;
	  while( (i<50) && ( exactSteps != i ) && (counter < 6) ) {
//cout << "      " << 3 + counter << ".Schritt :\n";	
	    ++counter;
	    globalSkills->resetSituation( s );
	    iTempTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(i), ball.speed().angle(), POLAR, RADIAN);
	    exactSteps = (globalSkills->gotoRegion( iTempTarget, targetRadius, globalConf->interceptBallStaminaLimit )).size();
//cout << "        exactSteps = "	<<  exactSteps << endl;
      if( i < exactSteps ) {
	      ++i;
	    }
	    else if( i > exactSteps ){
	      --i;
	    }
	  }

	  i = max( 0, i );
    j = min( j, nearestEnemyStepsToBall +1 );
	  j = max( i, j );
//cout << "      ==> I = " << i << "    J = " << j << endl;

		//man sollte versuchen, die bisherige Laufrichtung beizubehalten (Berechnung des Schnittpunktes)
		double psx = cos( player.bodyDir() );
		double psy = sin( player.bodyDir() );
//cout << "BodyDir = " << degFromRadiant( player.bodyDir() ) << endl;
//cout << "psx = " << psx << "     psy = " << psy << endl;
		double bsx = ball.speed().x() + 0.00001;
		double bsy = ball.speed().y() + 0.00001;
		double n =   (  ( player.pos().y() - ball.pos().y() ) / bsy
							    - ( player.pos().x() - ball.pos().x() ) / bsx )
							 / ( psx / bsx - psy / bsy );
//cout << "n = " << n << endl;							
    Vector interSect = Vector( player.pos().x() + n * psx,
    													 player.pos().y() + n * psy );							
 	  globalSkills->resetSituation( s );
  	int interSectSteps = (globalSkills->gotoRegion( interSect, targetRadius, globalConf->interceptBallStaminaLimit )).size();
//cout << "    Schnittpunkt mit der Balltrajektorie nach " << interSectSteps << " Schnritten\n";
//cout << "    Schnittpunkt : " << interSect << endl;
		Vector interSectBallPos = ball.pos();
		Vector interSectBallSpeed = ball.speed();
		double oldInterSectDist = (interSect - interSectBallPos).length();
		bool ballAlreadyPassed = (oldInterSectDist < targetRadius ? NO : YES);
		//
		for( int c = 1; c <= interSectSteps; ++c ) {
		  interSectBallPos += interSectBallSpeed;
		  interSectBallSpeed =interSectBallSpeed * globalConf->ballDecay;
		  if( (interSect - interSectBallPos).length() > oldInterSectDist ) {
		  	ballAlreadyPassed = YES;
		  	break;
		 	}
		 	oldInterSectDist = (interSect - interSectBallPos).length();
		 	ballAlreadyPassed = NO;
		}

    if( (ballAlreadyPassed == NO) && (interSectSteps <= j) && ( (interSect - interSectBallPos).length() < 1.5 ) ) {
//cout << "     Alles im Lot ;-)\n";
      if( (Lot - player.pos()).length() < 0.5) { // wir stehen schon auf der Balltrajektorie
//cout << "     wir stehen schon auf der Balltrajektorie\n";
      	ModelledBall nextBall = globalWorldModel->ball();
				nextBall.simulateSteps(1);
      	calculatedTarget = nextBall.pos();
      	calculatedSteps = i;
     	}
     	else {
	      calculatedSteps = interSectSteps;
	      calculatedTarget = interSect;
	    }
    }
    // koennte Probleme bereiten, wenn inzwischen ein Spieler den Ball gekickt hat
    else if(   ( (ourGoalieStepsToBall + simStepOfLastCalc) >= (i + globalWorldModel->simStep()) ) // wir knnen unser altes Target behalten
    				&& ( (ourGoalieStepsToBall + simStepOfLastCalc) <= (j + globalWorldModel->simStep()) ) ) {
//cout << "wir knnen unser altes Target behalten\n";
      calculatedSteps = ourGoalieStepsToBall + simStepOfLastCalc - globalWorldModel->simStep();
	    calculatedTarget = ourGoalieInterceptPosition ;
    }
		else {
//cout << "calculatedSteps = min( ((int) rint( 0.5 * (i+j) )) , i + 4 )\n";
	    calculatedSteps = min( ((int) rint( 0.5 * (i+j) )) , i + 2 );
      calculatedTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(calculatedSteps), ball.speed().angle(), POLAR, RADIAN);
    }

    goalieInterceptRunBehaviour = Skills::STANDARD_BEHAVIOR;

  } // end else (Ball bewegt sich)

//cout << "resulting GoalieInterceptTarget = " << calculatedTarget << "  nach " << calculatedSteps << endl;
}




void InterceptAnalyzer::calculateOptInterceptTarget(const ModelledPlayer& player, double targetRadius) {

//cout << "    calculateOptInterceptTarget()\n";

  if( targetRadius < 0.0 ) {
	targetRadius = player.kickRange() - 0.2 ;
  }

  const ModelledBall& ball = globalWorldModel->ball();

  Situation s = Situation( globalWorldModel->simStep() );
  ModelledPlayer hackPlayer = player;
  hackPlayer.setId( globalWorldModel->id() );
  s.setPlayer( hackPlayer );
  s.setBall( ball );

  if( ball.speed().length() < 0.05 ){
    calculatedTarget = ball.pos();
	  globalSkills->resetSituation(s);
    calculatedSteps = (globalSkills->gotoRegion( calculatedTarget, targetRadius, globalConf->interceptBallStaminaLimit )).size();
  }
  
  else { // Ball bewegt sich

	  int i; // Anfang der InterceptArea
	  int j; // Ende der InterceptArea
	  Vector iTempTarget;
	  Vector jTempTarget;

	// Lot berechnen
	double m = (   ( ball.pos().y() - player.pos().y() ) * ball.speed().y()
					  + ( ball.pos().x() - player.pos().x() ) * ball.speed().x() )
					/ ( ball.speed().x() * ball.speed().x() + ball.speed().y() * ball.speed().y() );
	Vector Lot = Vector( ball.pos().x() + m * ball.speed().x(),
											 ball.pos().y() + m * ball.speed().y(),
											 CARTESIAN );
//  globalSkills->resetSituation(); 
//	int lotSteps = (globalSkills->gotoRegion( Lot, 0.2, globalConf->interceptBallStaminaLimit )).size();


  // Schritt 1: Minimalabschtzung der Laufzeit bis zum Intercept
  // geschtzte Anzahl der Steps bis zum Target
	  double distBetweenPlayerAndBall;
	  Vector vi;
	  Vector speed = player.speed();
	  double playerVelocityInITempTargetDirection;
	  double playerVelocityOffset;
	
	  for( i=0; i<= 50; ++i ) {
	    iTempTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(i), ball.speed().angle(), POLAR, RADIAN);
  	  vi = iTempTarget - player.pos();
	    distBetweenPlayerAndBall = vi.length();
	    vi.normalize();
	    playerVelocityOffset = rint(10 * speed * vi);
	
	    if( distBetweenPlayerAndBall <= player.getMaxDistAfterSteps(i,playerVelocityOffset) + targetRadius ) {
	      break;
	    }
	  }
	  for( j=i+1; j<= 50; ++j ) {
	    jTempTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(j), ball.speed().angle(), POLAR, RADIAN);
	    distBetweenPlayerAndBall = ( jTempTarget - player.pos() ).length();
	    if( (distBetweenPlayerAndBall > player.getMaxDistAfterSteps(j) + targetRadius)
	        || ( fabs(jTempTarget.x()) > globalWorldModel->field().enemyGoal().x())
	        || ( fabs(jTempTarget.y()) > 0.5 * globalWorldModel->field().fieldWidth() )
	        || (nearestEnemyStepsToBall + 1 < j )
			    || (j > i+2) ) {
	      --j;
	      break;
	    }
	  }
	  j = max( i, j );

//cout << "      1.Schritt: i = " << i << "    j = " << j  << endl;
	  
	  // Schritt 2: Verschlechtern des Targets falls PlayerGeschwindigkeit
	  //   nicht in Zielrichtung zeigt
	  double iTempTargetDeviation = fabs( deviationBetween( (iTempTarget - player.pos()).angle(), speed.angle() ) ) ;
	  if( iTempTargetDeviation > radFromDegree(20) ){
	    ++i;
	    speed = player.decay() * speed;
	  }
	  if( iTempTargetDeviation > radFromDegree(60) ){
	    ++i;
	    speed = player.decay() * speed;
	  }
    speed = player.speed();
//cout << "      2.Schritt: i = " << i << "    j = " << j  << endl;

	  // Schritt 3: auf das tempTarget den goToRegionSkill anschmeissen
	  //   die Abweichung in den Steps analysieren und Target entsprechend nachfhren
	  //   nicht fr j! sonst wird j succesive nach i verschoben

	  --i;
	
	  int exactSteps = 1000;
	  int counter = 0;
	  while( (i<50) && ( exactSteps != i ) && (counter < 5) ) {
//cout << "      " << 3 + counter << ".Schritt :\n";	
	    ++counter;
	    globalSkills->resetSituation( s );
	    iTempTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(i), ball.speed().angle(), POLAR, RADIAN);
	    exactSteps = (globalSkills->gotoRegion( iTempTarget, targetRadius, globalConf->interceptBallStaminaLimit )).size();
//cout << "        exactSteps = "	<<  exactSteps << endl;
      if( i < exactSteps ) {
	      ++i;
	    }
	    else if( i > exactSteps ){
	      --i;
	    }
	  }
	  i = max( 0, i );
    j = min( j, nearestEnemyStepsToBall +1 );
	  j = max( i, j );
//cout << "      ==> I = " << i << "    J = " << j << endl;

		//man sollte versuchen, die bisherige Laufrichtung beizubehalten (Berechnung des Schnittpunktes)
		double psx = cos( player.bodyDir() );
		double psy = sin( player.bodyDir() );
//cout << "BodyDir = " << degFromRadiant( player.bodyDir() ) << endl;
//cout << "psx = " << psx << "     psy = " << psy << endl;
		double bsx = ball.speed().x() + 0.00001;
		double bsy = ball.speed().y() + 0.00001;
		double n =   (  ( player.pos().y() - ball.pos().y() ) / bsy
							    - ( player.pos().x() - ball.pos().x() ) / bsx )
							 / ( psx / bsx - psy / bsy );
//cout << "n = " << n << endl;							 
    Vector interSect = Vector( player.pos().x() + n * psx,
    													 player.pos().y() + n * psy );							 
 	  globalSkills->resetSituation( s );
  	int interSectSteps = (globalSkills->gotoRegion( interSect, targetRadius, globalConf->interceptBallStaminaLimit )).size();
//cout << "    Schnittpunkt mit der Balltrajektorie nach " << interSectSteps << " Schnritten\n";
//cout << "    Schnittpunkt : " << interSect << endl;
		Vector interSectBallPos = ball.pos();
		Vector interSectBallSpeed = ball.speed();
		double oldInterSectDist = (interSect - interSectBallPos).length();
		bool ballAlreadyPassed = (oldInterSectDist < targetRadius ? NO : YES);
		// 
		for( int c = 1; c <= interSectSteps; ++c ) {
		  interSectBallPos += interSectBallSpeed;
		  interSectBallSpeed =interSectBallSpeed * globalConf->ballDecay;
		  if( (interSect - interSectBallPos).length() > oldInterSectDist ) {
		  	ballAlreadyPassed = YES;
		  	break;
		 	}
		 	oldInterSectDist = (interSect - interSectBallPos).length();
		 	ballAlreadyPassed = NO;
		}

    if( (ballAlreadyPassed == NO) && (interSectSteps <= j) && ( (interSect - interSectBallPos).length() < 1.5 ) ) {
//cout << "     Alles im Lot ;-)\n";
      if( (Lot - player.pos()).length() < 0.5) { // wir stehen schon auf der Balltrajektorie
//cout << "     wir stehen schon auf der Balltrajektorie\n";
      	ModelledBall nextBall = globalWorldModel->ball();
				nextBall.simulateSteps(1);
      	calculatedTarget = nextBall.pos();
      	calculatedSteps = i;
     	}
     	else {
	      calculatedSteps = interSectSteps;
	      calculatedTarget = interSect;
	    }
    }
    else if(   ( (myStepsToBall + simStepOfLastCalc) >= (i + globalWorldModel->simStep()) ) // wir knnen unser altes Target behalten
    				&& ( (myStepsToBall + simStepOfLastCalc) <= (j + globalWorldModel->simStep()) ) ) {
//cout << "     wir knnen unser altes Target behalten\n";
      calculatedSteps = myStepsToBall + simStepOfLastCalc - globalWorldModel->simStep();
	    calculatedTarget = myInterceptPosition ;
    }
		else {
//cout << "     calculatedSteps = min( ((int) rint( 0.5 * (i+j) )) , i + 4 )\n";
	    calculatedSteps = min( ((int) rint( 0.5 * (i+j) )) , i + 2 );
      calculatedTarget = ball.pos() + Vector(ball.speed().length()*globalSkills->getNewBallDistance(calculatedSteps), ball.speed().angle(), POLAR, RADIAN);
    }
    
  } // end else (Ball bewegt sich)

//cout << "    resulting OptInterceptTarget = " << calculatedTarget << "  nach " << calculatedSteps << endl;
}