#include "PassAnalyzer.h"

#include "Analyzer.h"
#include "../basic/Timer.h"
#include "../worldmodel/WorldModelInterface.h"
#include "../worldmodel/Situation.h"



PassAnalyzer::PassAnalyzer()
{
	passPossible = NO;
	riskPassPossible = NO;
}


void PassAnalyzer::calculateValues() {
//int startTime = globalTimer->getAgentTime();

	passPossible = NO;
	riskPassPossible = NO;

	double maxAngle = radFromDegree(70); // Winkel links und rechts von prefferedKickDir, die auf Passmoeglichkeiten abgetestet wird
	double testAngle = 0.0;
	double step = radFromDegree(4.0); // Schritte in denen auf Passmoeglichkeiten getestet wird
	
	// double targetVectorLength = 15.0;
  double ballSpeed = 2.0; // angenommene erreichbare Ballgeschwindigkeit

	int safetySteps = 3; // Steps, die unser Spiele naeher am Ball sein muss, damit gepasst wird
	int riskSafetySteps = 1;
	double posConfMin = 0.6;

	int minLineDist = 4;
	
	bool addTestAngle = YES;
 	int ownPlayers = 0;
 	
 	Vector pessTarget;
	
 	Situation theSituation = globalWorldModel->situation();
    
  Vector myselfPos = theSituation.playerWithId( globalWorldModel->id() ).pos();
	Vector thePreferredKickDir = globalWorldModel->preferredKickDirection( myselfPos );
    
	ModelledBall theBall = globalWorldModel->ball();
     
  // eigenen Player rausnehmen
	theSituation.removePlayerWithId( globalWorldModel->id() );

	// alle eigenen Spieler mit zu geringer posConfidence aus der Situation rauswerfen 
	// - zu denen passen wir eh nicht -
	for( int i=0; i<theSituation.playerCount(); i++ ){
		if(	theSituation.playerWithIndex(i).team() == OUR_TEAM_ID ) {
			if(   ( theSituation.playerWithIndex(i).posConfidence().reliability() < posConfMin )
			    ||( globalWorldModel->field().isPositionInPenaltyArea( theSituation.playerWithIndex(i).pos() ) ) ) {
				theSituation.removePlayerWithId( theSituation.index2Id(i) );
			}
			else{
				++ownPlayers;
			}	
		} 			
	} 

	int ourSteps = 0;
	int theirSteps = 0;

	
	while( testAngle < maxAngle && passPossible == NO ) {

		// Abwechselnd wird der testAngle zum/vom  thePreferredKickDir.angle() addiert/abgezogen - und anschliessend um step erhoeht 
		if( addTestAngle == YES ) {
			theBall.setSpeed( Vector( ballSpeed, thePreferredKickDir.angle()+testAngle, POLAR, RADIAN));
			addTestAngle = NO;
		}	
		else {
			theBall.setSpeed( Vector( ballSpeed, thePreferredKickDir.angle()-testAngle, POLAR, RADIAN));
			addTestAngle = YES;
			testAngle += step;
		} 
		theSituation.setBall( theBall );
		ourSteps = theSituation.stepsOfNearestPlayer( OUR_TEAM_ID );
		theirSteps = theSituation.stepsOfNearestPlayer( THEIR_TEAM_ID );
		if( ourSteps + riskSafetySteps < theirSteps ) {
      passTarget = theBall.pos() + Vector( theBall.speed().length() * globalSkills->getNewBallDistance(ourSteps),
   	               theBall.speed().angle(), POLAR, RADIAN );
   	  pessTarget = theBall.pos() + Vector( theBall.speed().length() * globalSkills->getNewBallDistance(ourSteps + minLineDist),
   	               theBall.speed().angle(), POLAR, RADIAN );
   	  if( (globalWorldModel->field().isInsideField( passTarget ) == YES)
   	      && (globalWorldModel->field().isInsideField( pessTarget ) == YES)
   	      && (globalWorldModel->field().isPositionInPenaltyArea( passTarget ) == NO) ){
   	    if( (theBall.speed().x() > -0.2) || (passTarget.x() > -25.) ) {
          riskPassPossible = YES;
	        passReceiverId = theSituation.index2Id( theSituation.indexOfNearestPlayer( OUR_TEAM_ID ) );
          if( ourSteps + safetySteps < theirSteps ) {
			  	  passPossible = YES;
  			  	break;
          }
	  		}	
	    }
	 	}

  }//endwhile	

  passTarget = theBall.pos() + Vector( theBall.speed().length() * globalSkills->getNewBallDistance(ourSteps),
   				       theBall.speed().angle(), POLAR, RADIAN );

  if( globalWorldModel->field().isPositionInPenaltyArea(theBall.pos()) == YES ) {
    if( fabs(theBall.speed().angle()) > radFromDegree(60) ) {
        passTarget = Vector( 0.0, theBall.pos().y(), CARTESIAN );
    }
  }

//int duration = globalTimer->getAgentTime() - startTime;
//cerr << "PassAnalyzer::calculateValues in " << globalWorldModel->simStep() << "  in " << duration << " ms\n";

}

