#ifndef _PASS_ANALYZER_H_
#define _PASS_ANALYZER_H_

#include "../intentions/targets/Target.h"

class PassAnalyzer{
  public:
    PassAnalyzer();
    void calculateValues();

    bool isPassPossible();
    bool isRiskPassPossible();
 
    const Vector& getPassTarget();
    int getPassReceiverId();
    const Vector& getBeamPosition();
    
  protected:
    Vector passTarget;
    Vector beamPosition;
    bool passPossible;
    bool riskPassPossible;
    int passReceiverId;
};

inline bool PassAnalyzer::isPassPossible() {
	return passPossible;
}

inline bool PassAnalyzer::isRiskPassPossible() {
	return riskPassPossible;
}

inline const Vector& PassAnalyzer::getPassTarget() {
	return passTarget;
}

inline int PassAnalyzer::getPassReceiverId() {
	return passReceiverId;
}

inline const Vector& PassAnalyzer::getBeamPosition() {
	return beamPosition;
}

#endif
