#include "ScoreGoalAnalyzer.h"

#include "Analyzer.h"
#include "Grid.h"

#include "../basic/Timer.h"
#include "../intentions/skills/Skills.h"
#include "../worldmodel/WorldModelInterface.h"
#include "../worldmodel/Situation.h"

//ScoreGoalAnalyzer::ScoreGoalAnalyzer():Grid() {
ScoreGoalAnalyzer::ScoreGoalAnalyzer() 
{	
  setScoreGoalPossible( NO );
}

const Vector& ScoreGoalAnalyzer::getScoreGoalTarget()
{
  //if( timeStamp() != globalWorldModel->simStep() ) {
  //  calculateValues();
  //}
  return scoreGoalTarget;
}

bool ScoreGoalAnalyzer::isScoreGoalPossible()
{
  //if( timeStamp() != globalWorldModel->simStep() ) {
  //  calculateValues();
  //}
  return scoreGoalPossible;
}

bool ScoreGoalAnalyzer::isRiskScoreGoalPossible()
{
  return riskScoreGoalPossible;
}


void ScoreGoalAnalyzer::calculateValues( ) {
	
	
	//HACKHACKHACKHACKHACKHACKHACKHACKHACK

//	cout << "________________ Neue ScoreGoalAnalyzer Berechnung _____" << globalWorldModel->simStep() << "____________ " << endl;
	setScoreGoalPossible( NO );
	setRiskScoreGoalPossible( NO );

	// wenn wir weiter als globalConf->maxGoalKickDist weg sind, wird gar nicht erst gerechnet...
	// sollte gar nicht vorkommen, da der Analyzer nur aufgerufen werden soll, wenn wir in Tornaehe sind
	// da wir aber nie wissen... fragen wir hier trotzdem ab.
	if( globalWorldModel->player().distTo( globalWorldModel->field().enemyGoal()) > globalConf->maxGoalKickDist ) {
		return;	
	}	
			
	Situation theSituation = globalWorldModel->situation();
	Vector myselfPos = theSituation.playerWithId( globalWorldModel->id() ).pos();
	ModelledBall theBall = globalWorldModel->ball();

	// alle Teammates und den eigenen Player aus der Situation rausnehmen
	for( int i = 420 ; i <= 431 ; i++) {
		theSituation.removePlayerWithId( i );	
	}	
	
	// Abstand, den der Torschuss 
	// Winkel den das Tor vor uns aufspannt
	double maxAngle = fabs( deviationBetween( (myselfPos - globalWorldModel->field().enemyGoalTop()).angle(), (myselfPos - globalWorldModel->field().enemyGoalBottom()).angle() ) );
	//cout << "ScoreGoalAnalyzer : maxAngle " << degFromRadiant(maxAngle) << endl;

	// Winkel der von uns auf die Mitte des gegnerischen Tores zeigt
	double targetAngle = normalizeAngle( maxAngle/2 + (globalWorldModel->field().enemyGoalBottom()-myselfPos).angle());
	//cout << "ScoreGoalAnalyzer : targetAngle " << degFromRadiant(targetAngle) << endl;
	double testAngle = 0.0;
	double step = maxAngle/70; // radFromDegree(1);  
  	double ballSpeedValue = 2.4;

	// Magic-Numbers zum dran drehen....	
	// Simsteps, die bei der Berechung der Strecke, die die Gegner maximal zurueklegen, hinzugezaehlt werden
	int safetySteps = 1;
	int riskSafetySteps = -2; 
	int goalieCatchSteps = 1;
	

	
//	Vector ballPos = theBall.pos();
//	Vector ballSpeed = theBall.speed();
//
//	theBall.setSpeed( Vector( ballSpeedValue, targetAngle + testAngle, POLAR, RADIAN));
// 	theSituation.setBall( theBall );

	bool ballLost = NO; // wurde der Ball, bevor im Tor ankam, von einem gegenerischen Spieler erreicht?
	bool addTestAngle = YES; 

	while( testAngle < (maxAngle/2) && scoreGoalPossible==NO ) {
		// nach dem Rumsimulieren den Ball wieder auf seine Ursprungsposition setzen.
		theBall = globalWorldModel->ball();
		
		// Abwechselnd wird der testAngle zum/vom targetAngle addiert/abgezogen - und anschliessend um step erhoeht 
		if( addTestAngle == YES ) {
			theBall.setSpeed( Vector( ballSpeedValue, targetAngle + testAngle, POLAR, RADIAN));
	 		addTestAngle = NO;
		}	
		else {
			theBall.setSpeed( Vector( ballSpeedValue, targetAngle - testAngle, POLAR, RADIAN));
			addTestAngle = YES;
			testAngle += step;
		} 
		theSituation.setBall( theBall );
 		
		// testen, ob der Ball in 25 Steps im Tor ist oder vorher von einem gegnerischen Spieler abgefangen wird 
	 	int stepsToGoal = 0;
	 	Vector ballPos = theBall.pos();
	 	Vector ballSpeed = theBall.speed();
	 	while (globalWorldModel->field().isInsideField( ballPos ) == YES && stepsToGoal<25) {
	 		ballPos+=ballSpeed;
	 		ballSpeed=globalConf->ballDecay * ballSpeed;
	 		stepsToGoal++;
	 	}// Ende Ball-Simulations Schleife
	 			
		int stepsOfNearestPlayer = theSituation.stepsOfNearestPlayer( THEIR_TEAM_ID );
		if ((theSituation.nearestPlayer(THEIR_TEAM_ID).isGoalie() && 
		      stepsOfNearestPlayer+safetySteps+goalieCatchSteps> stepsToGoal) ||
		      (stepsOfNearestPlayer + safetySteps > stepsToGoal) ) {
		
		  setScoreGoalPossible( YES );
		  setScoreGoalTarget( ballPos ); 
		  	 		
		} 
	} // Ende Winkelschleife

	// RISK SCORE GOAL
	// wird nur berechnet, wenn noch kein Torschuss gefunden wurde.
	if ( scoreGoalPossible == NO ) {
		bool addTestAngle = YES; 
		while( testAngle < (maxAngle/2) && scoreGoalPossible==NO ) {
			// nach dem Rumsimulieren den Ball wieder auf seine Ursprungsposition setzen.
			theBall = globalWorldModel->ball();
			
			// Abwechselnd wird der testAngle zum/vom targetAngle addiert/abgezogen - und anschliessend um step erhoeht 
			if( addTestAngle == YES ) {
				theBall.setSpeed( Vector( ballSpeedValue, targetAngle + testAngle, POLAR, RADIAN));
		 		addTestAngle = NO;
			}	
			else {
				theBall.setSpeed( Vector( ballSpeedValue, targetAngle - testAngle, POLAR, RADIAN));
				addTestAngle = YES;
				testAngle += step;
			} 
			theSituation.setBall( theBall );
	 		
			// testen, ob der Ball in 25 Steps im Tor ist oder vorher von einem gegnerischen Spieler abgefangen wird 
		 	int stepsToGoal = 0;
		 	Vector ballPos = theBall.pos();
			Vector ballSpeed = theBall.speed();
		 	while (globalWorldModel->field().isInsideField( ballPos ) == YES && stepsToGoal<25) {
		 		ballPos+=ballSpeed;
		 		ballSpeed=globalConf->ballDecay * ballSpeed;
		 		stepsToGoal++;
		 	}// Ende Ball-Simulations Schleife
		 			
			int stepsOfNearestPlayer = theSituation.stepsOfNearestPlayer( THEIR_TEAM_ID );
			if ((theSituation.nearestPlayer(THEIR_TEAM_ID).isGoalie() && 
			      stepsOfNearestPlayer+riskSafetySteps+goalieCatchSteps> stepsToGoal) ||
			      (stepsOfNearestPlayer + riskSafetySteps > stepsToGoal) ) {
			
			  setRiskScoreGoalPossible( YES );
			  setScoreGoalTarget( ballPos ); 
			  	 		
			}

		} 
	} // Ende Risk-Score-Goal-If 

  INFO( Log::ANY,  10,  idString() , globalLog->infoStream
    << "ScoreGoalAnalyzer::calculateValues ended at " << globalTimer->getAgentTime() << endl );
}


