#ifndef _SCORE_GOAL_ANALYZER_H_
#define _SCORE_GOAL_ANALYZER_H_

#include "Grid.h"
#include "../intentions/targets/Target.h"

class ScoreGoalAnalyzer {
  public:
    ScoreGoalAnalyzer();
    void calculateValues( );
    const Vector& getScoreGoalTarget();
    bool isScoreGoalPossible();
    bool isRiskScoreGoalPossible();


  protected:
    void setScoreGoalTarget( Vector v );
    void setScoreGoalPossible( bool value = NO );
    void setRiskScoreGoalPossible( bool value = NO );
    Vector scoreGoalTarget;
    bool scoreGoalPossible;
    bool riskScoreGoalPossible;
};


inline void ScoreGoalAnalyzer::setScoreGoalTarget( Vector v )
{
   scoreGoalTarget = v;
}

inline void ScoreGoalAnalyzer::setScoreGoalPossible( bool value )
{
  scoreGoalPossible = value;
}

inline void ScoreGoalAnalyzer::setRiskScoreGoalPossible( bool value )
{
  riskScoreGoalPossible = value;
}

#endif

