/*
 * Aktueller Stand
 *
 *   $RCSfile: Deliberator.cc,v $
 *   $Revision: 1.1.1.1 $
 *   $Date: 2001/07/31 22:23:08 $
 *   $Author: rami $
 *
 */

#include "Deliberator.h"

#include "Timer.h"

#include "../analyzer/Analyzer.h"
#include "../intentions/complexIntentions/EmergencyIntention.h"

#include "../intentions/roles/StandardGoalieRole.h"
#include "../intentions/roles/StandardRole.h"


Deliberator::Deliberator()
{
   theIdString = "Deliberator";
}


void Deliberator::initialize(){
  INFO( Log::DELIBERATOR  , 6 , idString() , globalLog->infoStream <<
	" ENTER Deliberator::initialize\n"  ) ;
  // globalAnalyzer muss zuerst angelegt werden, weil PlaySoccerIntention ihn benutzt
  globalAnalyzer = new Analyzer;
  globalEmergencyIntention = new EmergencyIntention;
  if( globalWorldModel->player().isGoalie() == YES ) {
    theRole = new StandardGoalieRole();
  }
  else {
    theRole = new StandardRole();
  }
  // legt IntentionListe an (zum ersten mal)
  theRole->deliberate();

//  cerr << "leave Deliberator::initialize\n";

  INFO( Log::DELIBERATOR  , 6 , idString() , globalLog->infoStream <<
	" LEAVE Deliberator::initialize\n"  ) ;
}

void Deliberator::deliberate()
{
  for(;;){
    // Die Schleife, in der nachgedacht wird.

    globalTimer->controller();
    // hier muss der Analyzer aufgerufen werden
    theRole->deliberate();

    globalTimer->agentSleep();
  }
}

Action Deliberator::execute()
{
  return theRole->execute();
}
