/*
 * Aktueller Stand 
 * 
 *   $RCSfile: Formation.cc,v $
 *   $Revision: 1.1.1.1 $ 
 *   $Date: 2001/07/31 22:23:08 $ 
 *   $Author: rami $  
 * 
 */ 


#include <stdio.h>
#include "Formation.h"


Formation *globalFormation;

// Konstruktor
Formation::Formation()
{
  theIdString = "Formation";

  // funzt nicht
  readFormations();

/*
// FORMATION 1

  // posx
  FM_Position[0][0][0].setX(-49.5);
  FM_Position[0][0][1].setX(-6.0);
  FM_Position[0][0][2].setX(3.5);
  FM_Position[0][0][3].setX(3.5);
  FM_Position[0][0][4].setX(-17.0);
  FM_Position[0][0][5].setX(-17.0);
  FM_Position[0][0][6].setX(-25.0);
  FM_Position[0][0][7].setX(-36.0);
  FM_Position[0][0][8].setX(-36.0);
  FM_Position[0][0][9].setX(-36.0);
  FM_Position[0][0][10].setX(-36.0);

  // posy
  FM_Position[0][0][0].setY(0.0);
  FM_Position[0][0][1].setY(0.0);
  FM_Position[0][0][2].setY(25.0);
  FM_Position[0][0][3].setY(-25.0);
  FM_Position[0][0][4].setY(16.0);
  FM_Position[0][0][5].setY(-16.0);
  FM_Position[0][0][6].setY(0.0);
  FM_Position[0][0][7].setY(19.0);
  FM_Position[0][0][8].setY(7.0);
  FM_Position[0][0][9].setY(-7.0);
  FM_Position[0][0][10].setY(-19.0);

  //playertype
  FM_PlayerType[0][0] = 0;
  FM_PlayerType[0][1] = 3;
  FM_PlayerType[0][2] = 3;
  FM_PlayerType[0][3] = 3;
  FM_PlayerType[0][4] = 2;
  FM_PlayerType[0][5] = 2;
  FM_PlayerType[0][6] = 2;
  FM_PlayerType[0][7] = 1;
  FM_PlayerType[0][8] = 1;
  FM_PlayerType[0][9] = 1;
  FM_PlayerType[0][10] = 1;

  // attractionx
  FM_Attraction[0][0].setX(0.1);
  FM_Attraction[0][1].setX(0.5);
  FM_Attraction[0][2].setX(0.5);
  FM_Attraction[0][3].setX(0.5);
  FM_Attraction[0][4].setX(0.5);

  //attractiony
  FM_Attraction[0][0].setY(0.1);
  FM_Attraction[0][1].setY(0.25);
  FM_Attraction[0][2].setY(0.25);
  FM_Attraction[0][3].setY(0.25);
  FM_Attraction[0][4].setY(0.25);

  // behind ball
  FM_BehindBall[0][0] = 1;
  FM_BehindBall[0][1] = 1;
  FM_BehindBall[0][2] = 0;
  FM_BehindBall[0][3] = 0;
  FM_BehindBall[0][4] = 0;

  // minx
  FM_MinX[0][0] = -52.5;
  FM_MinX[0][1] = -42.0;
  FM_MinX[0][2] = -38.0;
  FM_MinX[0][3] = -20.0;
  FM_MinX[0][4] = -42.0;

  // max
  FM_MaxX[0][0] = -30.0;
  FM_MaxX[0][1] = 0.0;
  FM_MaxX[0][2] = 35.0;
  FM_MaxX[0][3] = 42.0;
  FM_MaxX[0][4] = 42.0;
*/

  formation = 0;           //Formation
  for( int i=1; i <= 11; ++i ) FM_Positioning[i] = i;
}

void Formation::readFormations()
{
  FILE *fich;
  char line1[512], *str;

  if ((fich=fopen("formations.conf","r"))==NULL) {
	fprintf(stderr,"Formation Configuration File does not Exist!\n"); return; }

  for( int i=0; i < NUM_FORM; ++i) {
        fgets(line1, 200, fich); fgets(line1, 30, fich);
        fgets(line1, 200, fich); str = &line1[0];
	      for( int t=1; t<=11; ++t ) FM_Position[i][0][t].setX( get_float(&str) );

        fgets(line1, 200, fich); str = &line1[0];
        for( int t=1; t<=11; ++t ) FM_Position[i][0][t].setY( get_float(&str) );

        fgets(line1, 200, fich); str = &line1[0];
        for( int t=1; t<=11; ++t ) FM_PlayerType[i][t] = get_int(&str);

        fgets(line1, 200, fich); str = &line1[0];
        for( int k=0; k<NUM_PLTYPES; ++k ) FM_Attraction[i][k].setX( get_float(&str) );

        fgets(line1, 200, fich); str = &line1[0];
        for( int k=0; k<NUM_PLTYPES; ++k ) FM_Attraction[i][k].setY( get_float(&str) );

        fgets(line1, 200, fich); str = &line1[0];
        for( int k=0; k<NUM_PLTYPES; ++k ) FM_BehindBall[i][k] = get_int(&str);

        fgets(line1, 200, fich); str = &line1[0];
        for( int k=0; k<NUM_PLTYPES; ++k ) FM_MinX[i][k] = get_float(&str);

        fgets(line1, 200, fich); str = &line1[0];
        for( int k=0; k<NUM_PLTYPES; ++k ) FM_MaxX[i][k] = get_float(&str);
  }
  fclose(fich);
}

/****************************************************************************/
/* These routines are to save time instead of using sscanf or atof, etc.    */
/* When passing **str_ptr, the pointer is advanced past the number          */
/* When passing  *str    , the pointer remains where it was before          */
/****************************************************************************/

double Formation::get_double(char **str_ptr){

  double d_frac, result;
  int  m_flag, d_flag;

  d_frac = 1.0;
  result = 0.0;
  m_flag = d_flag = 0;

  /* Advance to the beginning of the number */
  while( !isdigit(**str_ptr) && **str_ptr!='-' && **str_ptr!='.')
    (*str_ptr)++;

  /* Process the number bit by bit */
  while((**str_ptr!=')') && (**str_ptr!=' ') && (**str_ptr!='\n') && (**str_ptr!=',')){
    if (**str_ptr=='.')
      d_flag=1;
    else if (**str_ptr=='-')
      m_flag=1;
    else if (d_flag){
      d_frac *= 10.0;
      result+=(double)(**str_ptr-'0')/d_frac;
    }
    else
      result=result*10.0+(double)(**str_ptr-'0');
    (*str_ptr)++;
  }
  if (m_flag)
    result=-result;

  //printf("%.1f\n",result);

  return result;
}

/* Get the number, but don't advance pointer */

double Formation::get_double(char *str){
  char **str_ptr = &str;
  return get_double(str_ptr);
}

/****************************************************************************/

float Formation::get_float(char **str_ptr){

  float d_frac, result;
  int  m_flag, d_flag;

  d_frac = 1.0;
  result = 0.0;
  m_flag = d_flag = 0;

  /* Advance to the beginning of the number */
  while( !isdigit(**str_ptr) && **str_ptr!='-' && **str_ptr!='.')
    (*str_ptr)++;

  /* Process the number bit by bit */
  while((**str_ptr!=')') && (**str_ptr!=' ') && (**str_ptr!='\n') && (**str_ptr!=',')){
    if (**str_ptr=='e')
      cerr << "There's an e in my float! " << *str_ptr << endl;
    if (**str_ptr=='.')
      d_flag=1;
    else if (**str_ptr=='-')
      m_flag=1;
    else if (d_flag){
      d_frac *= 10.0;
      result+=(float)(**str_ptr-'0')/d_frac;
    }
    else
      result=result*10.0+(float)(**str_ptr-'0');
    (*str_ptr)++;
  }
  if (m_flag)
    result=-result;

  //printf("%.1f\n",result);

  return result;
}

/* Get the number, but don't advance pointer */

float Formation::get_float(char *str){
  char **str_ptr = &str;
  return get_float(str_ptr);
}

/****************************************************************************/

int Formation::get_int(char **str_ptr){

  int result;
  int m_flag;

  result = 0;
  m_flag = 0;

  /* Advance to the beginning of the number */
  while( !isdigit(**str_ptr) && **str_ptr!='-')
    (*str_ptr)++;

  /* Process the number bit by bit */
  while((**str_ptr!=')') && (**str_ptr!=' ') && (**str_ptr!='\n') && (**str_ptr!=',')){
    if (**str_ptr=='-')
      m_flag=1;
    else
      result=result*10+(int)(**str_ptr-'0');
    (*str_ptr)++;
  }
  if (m_flag)
    result=-result;

  return result;
}

int Formation::get_int(char *str){
  char **str_ptr = &str;
  return get_int(str_ptr);
}

/****************************************************************************/

void Formation::get_word(char **str_ptr){
  while ( !isalpha(**str_ptr) ) (*str_ptr)++;
}

/****************************************************************************/

void Formation::get_next_word(char **str_ptr){
  while ( isalpha(**str_ptr) ) (*str_ptr)++;
  get_word(str_ptr);
}

/****************************************************************************/

void Formation::get_token (char **str_ptr)
{
  advance_past_space(str_ptr);
  while ( (*str_ptr) && !isspace(**str_ptr)) (*str_ptr)++;
}

/****************************************************************************/

void Formation::advance_to(char c, char **str_ptr){
  while ( **str_ptr != c ) (*str_ptr)++;
}

/****************************************************************************/

void   Formation::advance_past_space(char **str_ptr)
{
  while ( (*str_ptr) && isspace(**str_ptr)) (*str_ptr)++;
}

 
;  
