#ifndef _FORMATION_H_
#define _FORMATION_H_

#include <string>
#include "Vector.h"

class Formation2
{
public:
  Formation2();

  /** Destruktor. */
  ~Formation2();

  Vector formationGetPosition( int playerNumber );
  Vector formationGetAttraction( int playerNumber );
  int formationGetBehindBall( int playerNumber );
  float formationGetMaxX( int playerNumber );
  float formationGetMinX( int playerNumber );

private:
  /* Liest die Formation ein */
  void readFormations();

  /** Private Fehlerklasse, die in indexOfBestDesire ausgeloest wird. */
  /** String der die Kurzkennung der Klasse enthlt */
  string theIdString;

  /** Liefert einen String mit Klassenbezeichnung zurueck. */
  string idString() const;

  // die Formation erfragen
  int getFormation() const;

  // die Formation festlegen
  void setFormation( int newFormation );

  static const int NUM_FORM = 1;      //Formations (like 433Open, 422, etc)
  static const int NUM_PLTYPES = 5;   //Player Types
  int formation;           //Formation

  // diese Arrays enthalten fr die Positionierung wichtige Werte
  int FM_Positioning[12];
  Vector FM_Position[NUM_FORM+1][1][12];
  int FM_PlayerType[NUM_FORM+1][12];
  Vector FM_Attraction[NUM_FORM+1][NUM_PLTYPES+1];
  int FM_BehindBall[NUM_FORM+1][NUM_PLTYPES+1];
  float FM_MinX[NUM_FORM+1][NUM_PLTYPES+1];
  float FM_MaxX[NUM_FORM+1][NUM_PLTYPES+1];

  // Hilsroutinen zum einlesen
  double get_double(char **str_ptr);
  double get_double(char *str);
  float  get_float (char **str_ptr);
  float  get_float (char *str);
  int    get_int   (char **str_ptr);
  int    get_int   (char *str);
  void   get_word  (char **str_ptr);
  void   get_next_word (char **str_ptr);
  void   get_token  (char **str_ptr);
  void   advance_to(char c, char **str_ptr);
  void   advance_past_space(char **str_ptr);
};

extern Formation2 *globalFormation2;

inline string Formation2::idString() const
{ 
  return theIdString;
}

inline Vector Formation2::formationGetPosition( int playerNumber )
{
  return FM_Position[formation][0][FM_Positioning[playerNumber]];
}

inline Vector Formation2::formationGetAttraction( int playerNumber )
{
  return FM_Attraction[formation][FM_PlayerType[formation][FM_Positioning[playerNumber]]];
}

inline int Formation2::getFormation() const
{
  return formation;
}

inline void Formation2::setFormation( int newFormation )
{
  formation = newFormation;
}

inline int Formation2::formationGetBehindBall( int playerNumber )
{
  return FM_BehindBall[formation][FM_PlayerType[formation][FM_Positioning[playerNumber]]];
}

inline float Formation2::formationGetMinX( int playerNumber )
{
  return FM_MinX[formation][FM_PlayerType[formation][FM_Positioning[playerNumber]]];
}

inline float Formation2::formationGetMaxX( int playerNumber )
{
  return FM_MaxX[formation][FM_PlayerType[formation][FM_Positioning[playerNumber]]];
}

#endif

