#ifndef _SAY_H_
#define _SAY_H_

#include "Action.h"
#include "../worldmodel/WorldModelInterface.h"

#include <string>

class Say{
 public:
    /**@name Konstanten. */
    //@{
    static const unsigned short int WORLD_MODEL = 1;
    //@}
   
    /** Konstruktor. */
    Say();
    /** Muss eine SayAction gesendet werden. */
    bool needToSendSayAction() const;
    /** Setzen, da\3 eine SayAction gesendet wird. */
    void setNeedToSendSayAction( bool yesOrNo = true );
    
    /** Die zu sendende SayAction ausgeben. */
    Action getSayCommand() const;
    /** Die zu sendende SayAction anlegen. */
    void setSayAction( const string& message );
    void setSayAction( const Ath98String& message );
    void setSayAction( unsigned short int flag );
    
    
    
 private:
    /** Die SayAction. */
    Action theSayAction;
    /** Flag, das aussagt, ob eine SayAction gesendet werden soll. */
    bool theNeedToSendSayAction;
    /** Zeitstempel der Generierung der SayAction. */
    int theSimStepOfSayAction;
};

inline bool Say::needToSendSayAction() const{
    return theNeedToSendSayAction;
}

inline void Say::setNeedToSendSayAction( bool yesOrNo ){
    theNeedToSendSayAction = yesOrNo;
}

inline Action Say::getSayCommand() const
{
  return theSayAction;
}
extern Say* globalSay;

#endif
