 
/* 
 * Aktueller Stand 
 * 
 *   $RCSfile: StraightLine.cc,v $ 
 *   $Revision: 1.1.1.1 $ 
 *   $Date: 2001/07/31 22:23:08 $ 
 *   $Author: rami $  
 * 
 */ 
  
#include "StraightLine.h" 
 
// Konstruktor 
StraightLine::StraightLine() : thePoint(), theDirection() {} 
 
// Konstruktor 
StraightLine::StraightLine( const Vector& aPoint, 
			    const Vector& aPointOrDirection, 
			    bool withDirection) : 
  thePoint( aPoint ), theDirection( aPointOrDirection )  
{ 
  if ( withDirection == POINT){ 
    theDirection = aPointOrDirection - aPoint;  
  } 
  theDirection.normalize();  
} 
 
// Das Lot  
Vector StraightLine::rightAngledVector() const 
{ 
  Vector perpendicular;  
   
  if ( theDirection.x() ) { 
    perpendicular.setCartesian( -( theDirection.y() / theDirection.x() ), 1 );  
  } 
  /* wenn x und y null sind, dann den Null-Vektor zurueck */ 
  else if ( !theDirection.y() ) { 
    perpendicular.setCartesian( 0, 0 );  
    return perpendicular;  
  } 
  else { 
    perpendicular.setCartesian( 1, - ( theDirection.x() / theDirection.y() ) );  
  } 
  perpendicular.normalize();  
  return perpendicular;  
} 
 
Vector StraightLine::calcPoint( double amount ) const 
{ 
  Vector newPoint = thePoint;  
  newPoint += ( amount * theDirection );  
  return newPoint;  
} 
 
double StraightLine::distTo( const Vector& aVector ) const 
{ 
  return fabs( ( ( theDirection.x()*( aVector.y()-thePoint.y() ) - 
		  theDirection.y()*( aVector.x()-thePoint.x() ) ) ) / 
	      theDirection.length() );  
} 
 
 
     
Vector StraightLine::point() 
{ 
  return thePoint;  
} 
 
Vector StraightLine::direction() 
{ 
  return theDirection;  
} 
	 
Ath98String StraightLine::toString() const 
{ 
  Ath98String output = Ath98String( "Gerade::    thePoint: ( " ) + 
                  thePoint.toString() + 
                  Ath98String( "\nGerade::theDirection: ( " ) + 
                  theDirection.toString();  
  return output;  
} 
 
 
 
;  
