 
/** 
 * Aktueller Stand 
 * 
 *   $RCSfile: CommonCoach.cc,v $ 
 *   $Revision: 1.3 $ 
 *   $Date: 2001/07/30 14:51:58 $ 
 *   $Author: wendler $  
 * 
 */
#include "./CommonCoach.h"
#include "../../basic/Common.h"
#include "../../basic/Ath98String.h"
#include "../../basic/Exception.h"

double globalComparisonAccuracy = DEFAULT_COMPARISON_ACCURACY;  
  
double normalizeAngle(double angle)  
{ 
  double phaseShift;  
 
  if( angle == UNDEF_DOUBLE ) { 
    throwException( Exception( Ath98String("Cannot normalize undef angle") ) );
  } 
  else if ( angle > Ath98_PI ) { 
    phaseShift = floor( ( angle + Ath98_PI ) / ( 2.0 * Ath98_PI) );  
    angle -= phaseShift * ( 2.0 * Ath98_PI );  
  } 
  else if ( angle < -Ath98_PI ) { 
    phaseShift = -ceil( ( angle - Ath98_PI ) / ( 2.0 * Ath98_PI) );  
    angle += phaseShift * ( 2.0 * Ath98_PI );  
  }   
 
  return angle;  
} 

int playerNumberById( int id )
{
  if( id >= MIN_OPPONENT_ID && id <= MAX_EXISTING_OPPONENT_ID ) {
    return( id - MIN_OPPONENT_ID + 1 );
  }
  else if( id >= MIN_TEAMMATE_ID && id <= MAX_EXISTING_TEAMMATE_ID ) {
    return( id - MIN_TEAMMATE_ID + 1 );
  }
  else {
    return -1;
  }
}
 


