#ifndef _DELIBERATOR_H_
#define _DELIBERATOR_H_

#include <string>
#include <stdio.h>
#include "TeamInfo.h"
class Sensors;
class Effectors;

/**
  Diese Klasse ist f\"ur die Entscheidungsfindung zust\"andig.
  Hier wird nachgedacht, was zu tun ist oder \"uber was sich der
  Kopf zerbrochen wird.
 
  {\small {\bf Quelltext}

  [\URL[Header]{src/Deliberator.h} | [\URL[Implementierung]{src/Deliberator.cc}]

  {\bf CVS Informationen zum Interface}
  \begin{verbatim}
  **************************************************
  *
  * Aktueller Stand
  *
  *   $RCSfile: Deliberator.h,v $
  *   $Revision: 1.6 $
  *   $Date: 2001/08/02 13:30:44 $
  *   $Author: wendler $ 
  *
  **************************************************
  \end{verbatim} }*/
class Deliberator
{
public:
  /** Konstruktor. */
  Deliberator( Sensors *sensors, Effectors *effectors );
  /** Destruktor. */
  ~Deliberator();
  /** Initialisierung. */
  void initialize();

  /** Das l\"angerfristige Nachdenken. */
  void deliberate();

  /** Das kurzfristige Nachdenken. */
  void execute();

  /** Liefert einen String mit Klassenbezeichnung zurueck. */
  string idString() const;

private:
  Sensors* theSensors;
  Effectors* theEffectors;
  /** String der die Kurzkennung der Klasse enth\"alt */
  string theIdString;

private:

  void changePlayerTypes();
  void analyseIdentify();

  void sendMessageToPlayers();
 
  //int criticalPairs[7][7]; 

  int lastMessageSentTime;

  /* Coach functions for evaluating best hetro-player */
  void evaluatePlayerTypes();
  vector<int> playerTypes;
  bool alreadyAllPlayersExchanged;
  unsigned int playerIndexToExchangeNext;
  unsigned int skippedGoalie;
};

#endif
