#ifndef _TEAMINFO_H_INCLUDED_
#define _TEAMINFO_H_INCLUDED_

#include "../../basic/Vector.h"
#include "../../basic/Ath98String.h"

class TeamInfo
{
public:
  TeamInfo();
  ~TeamInfo();

  struct PlayerTypeAssignment {
    int       playerType;
    float     confidence;
  };
  struct TeamPlayerTypes {
    PlayerTypeAssignment   pta[22][7] ;
  };

  PlayerTypeAssignment possibleTypes[22][7];
  void CalcPlayerTypes();
  const TeamPlayerTypes& getPlayerTypes();
  int typeOfPlayerWithIndex( int index );

  class PlayerInfo
  {
  public:
    int		playerIndex;
    float	maxSpeed;
    float	avgDecay;
    float   minDecay;
    float   maxDecay;
    int     DecayCount;
	float 	maxKickRange;
	int     playerType;
    float   dashValue;

    void CalcPlayerMaxSpeed();
    void CalcPlayerDecay();
    void CalcPlayerDashValue();

	float	lastRotation;
    Vector	lastSpeed;
    Vector  lastPos;

	void SafeState();

    void Initialize(int iIndex);
    void Output();
  };

  bool CouldHaveKicked(int iPlayerIndex);
  void CalcPlayerMaxKickRange(int playerIndex);

  void Calculate();

  Vector lastBallPos;
  Vector lastBallSpeed;

  void Initialize();
  void Output();

  int playerCount;
  int playerTypeCount;
  PlayerInfo* playerInfos;

  bool changedOpponentPlayerTypeByNumber[12];
  void parseSubstituteMessage(const Ath98String& message);
};

extern TeamInfo *globalTeamInfo;

#endif
