#ifndef _EFFECTORS_H_
#define _EFFECTORS_H_

#include <string>
#include "../../basic/Exception.h"

/**
  Diese Klasse ist die Superklasse fuer moegliche Effector-Klassen
 
  {\small {\bf Quelltext}

  [\URL[Header]{src/Effectors.h} | [\URL[Implementierung]{src/Effectors.cc}]

  {\bf CVS Informationen zum Interface}
  \begin{verbatim}
  **************************************************
  *
  * Aktueller Stand
  *
  *   $RCSfile: Effectors.h,v $
  *   $Revision: 1.5 $
  *   $Date: 2001/06/18 15:41:14 $
  *   $Author: wendler $ 
  *
  **************************************************
  \end{verbatim} }*/
class Effectors
{
public:
  /** Interne Fehlerklasse. */
  class EffectorsException: public Exception 
    {
  public:
      EffectorsException(const Ath98String& aDescription )
        : Exception( aDescription ) {}
    };

protected:  
  /** Erzeugt ein neues Effectors-Objekt. */
  Effectors();

  virtual ~Effectors();

public:
  /** Anmeldung auf dem Spielfeld. 
      Ist das nicht moeglich, wird eine EffectorsException erzeugt.  */
  virtual void enterField( const Ath98String& aTeamName ) const;

  /** Schickt das Kommando zum Oeffnen der Augen an den SoccerServer. */
  virtual void openEyes() const;

  /** Schickt das Kommando, dass der Spieler mit der Nummer playerNum
      durch einen Spieler des Types type ausgetauscht wird. */
  virtual void changePlayerType(int playerNum, int type ) const;

  /** Sendet einen Ruf der in der Coach-Language verfasst sein sollte. */
  virtual void sayMessage( const Ath98String& message ) const;

protected:  
  /** String der die Kurzkennung der Klasse enth\"alt */
  string theIdString;

};

#endif
