#ifndef _EFFECTORS_RECORD_H_
#define _EFFECTORS_RECORD_H_

#include "./Effectors.h"

/**
  Diese Klasse ist eine Dummy-Klasse, damit das Einlesen eines Recfiles
  genauso funktioniert als wenn der Coach mit dem SoccerServer
  verbunden waere.
 
  {\small {\bf Quelltext}

  [\URL[Header]{src/EffectorsRecord.h} | [\URL[Implementierung]{src/EffectorsRecord.cc}]

  {\bf CVS Informationen zum Interface}
  \begin{verbatim}
  **************************************************
  *
  * Aktueller Stand
  *
  *   $RCSfile: EffectorsRecord.h,v $
  *   $Revision: 1.2 $
  *   $Date: 2001/06/18 15:41:14 $
  *   $Author: wendler $ 
  *
  **************************************************
  \end{verbatim} }*/
class EffectorsRecord : public Effectors
{
public:
  
  /** Erzeugt ein neues Effectors-Objekt. */
  EffectorsRecord();

  ~EffectorsRecord();

  /** Anmeldung auf dem Spielfeld. */
  virtual void enterField( const Ath98String& aTeamName ) const;

  /** Schickt das Kommando zum Oeffnen der Augen an den SoccerServer. */
  virtual void openEyes() const;

  /** Schickt das Kommando, dass der Spieler mit der Nummer playerNum
      durch einen Spieler des Types type ausgetauscht wird. */
  virtual void changePlayerType(int playerNum, int type ) const;

  /** Sendet einen Ruf der in der Coach-Language verfasst sein sollte. */
  virtual void sayMessage( const Ath98String& message ) const;

private:

};

#endif
