
/*
 * Aktueller Stand
 *
 *   $RCSfile: EffectorsServer.cc,v $
 *   $Revision: 1.2 $
 *   $Date: 2001/06/18 15:41:14 $
 *   $Author: wendler $ 
 *
 */
 
#include "EffectorsServer.h"
#include "../../basic/InvalidIdException.h"

EffectorsServer::EffectorsServer( Communicator* aCommunicator )
  : Effectors(), theCommunicator( aCommunicator ) {
  theIdString = "EffectorsServer";
}

EffectorsServer::~EffectorsServer() 
{
}

void EffectorsServer::enterField( const Ath98String& aTeamName ) const 
{
  Ath98String message = "(init " + aTeamName + " (version 7.0))"; 
  theCommunicator->sendMessage( message );
}

void EffectorsServer::openEyes() const 
{
  Ath98String message = "(eye on)";
  theCommunicator->sendMessage( message );
}

void EffectorsServer::changePlayerType(int playerNum, int type ) const
{
  if( playerNum < 1 || playerNum > 11 ) {
    throwException( InvalidIdException( "Invalid player number given." ) );
  }
  if( type < 0 || type >= 7 ) { //7 ersetzen durch globalConf->playerTypes
    throwException( InvalidIdException( "Invalid exchange type given." ) );
  }
  Ath98String message = "(change_player_type " + Ath98String( playerNum ) +
    " " + type + ")";
  theCommunicator->sendMessage( message );
}

void EffectorsServer::sayMessage( const Ath98String& sayMessage ) const
{
  Ath98String message = "(say " + sayMessage + ")";
  theCommunicator->sendMessage( message );
}
