#include "IntentionDictionary.h"

#include "basicIntentions/DummyIntention.h"
#include "basicIntentions/GoToIntention.h"
#include "basicIntentions/KickIntention.h"
#include "basicIntentions/MoveIntention.h"
#include "basicIntentions/PMoveIntention.h"
#include "basicIntentions/WaitIntention.h"
#include "basicIntentions/TurnIntention.h"
#include "basicIntentions/SayIntention.h"
#include "basicIntentions/InitialScanIntention.h"


#include "complexIntentions/GetBallIntention.h"
#include "complexIntentions/InterceptBallIntention.h"
#include "complexIntentions/ParallelWalkIntention.h"
#include "complexIntentions/FreeKickIntention.h"
#include "complexIntentions/PositionIntention.h"
#include "complexIntentions/PPositionIntention.h"
#include "complexIntentions/PPositionIntention2.h"
#include "complexIntentions/DribbleIntention.h"
#include "complexIntentions/PassIntention.h"
#include "complexIntentions/TrivialPassIntention.h"
#include "complexIntentions/ScoreGoalIntention.h"

#include "complexIntentions/EmergencyIntention.h"
#include "complexIntentions/ScanFieldIntention.h"
	

#include "goalieIntentions/GoalieCatchIntention.h"
#include "goalieIntentions/GoalieGoalKickIntention.h"
#include "goalieIntentions/GoalieMoveIntention.h"
#include "goalieIntentions/GoalieInterceptIntention.h"
#include "goalieIntentions/GoaliePositionIntention.h"

IntentionDictionary globalIntentionDictionary;

void initializeIntentionDictionary(){
  globalIntentionDictionary[ DummyIntention::theId ] =
    "DummyIntention";
  globalIntentionDictionary[ GetBallIntention::theId ] =
    "GetBallIntention";
  globalIntentionDictionary[ GoToIntention::theId ] =
    "GoToIntention";
  globalIntentionDictionary[ KickIntention::theId ] =
    "KickIntention";
  globalIntentionDictionary[ MoveIntention::theId ] =
    "MoveIntention";
  globalIntentionDictionary[ PMoveIntention::theId ] =
    "PMoveIntention";
  globalIntentionDictionary[ WaitIntention::theId ] =
    "WaitIntention";
  globalIntentionDictionary[ TurnIntention::theId ] =
    "TurnIntention";
  globalIntentionDictionary[ InterceptBallIntention::theId ] =
    "InterceptBallIntention";
  globalIntentionDictionary[ ParallelWalkIntention::theId ] =
    "ParallelWalkIntention";
  globalIntentionDictionary[ FreeKickIntention::theId ] =
    "FreeKickIntention";
  globalIntentionDictionary[ PositionIntention::theId ] =
    "PositionIntention";
  globalIntentionDictionary[ PPositionIntention::theId ] =
    "PPositionIntention";
  globalIntentionDictionary[ PPositionIntention2::theId ] =
    "PPositionIntention2";
  globalIntentionDictionary[ SayIntention::theId ] =
    "SayIntention";

  globalIntentionDictionary[ EmergencyIntention::theId ] =
    "EmergencyIntention";
  globalIntentionDictionary[ ScanFieldIntention::theId ] =
  "ScanFieldIntention";
  globalIntentionDictionary[ InitialScanIntention::theId ] =
  "InitialScanIntention";
 
  globalIntentionDictionary[ GoalieCatchIntention::theId ] =
    "GoalieCatchIntention";
  globalIntentionDictionary[ GoalieGoalKickIntention::theId ] =
    "GoalieGoalKickIntention";
  globalIntentionDictionary[ GoalieMoveIntention::theId ] =
    "GoalieMoveIntention";
  globalIntentionDictionary[ GoaliePositionIntention::theId ] =
    "GoaliePositionIntention";
  globalIntentionDictionary[ GoalieInterceptIntention::theId ] =
    "GoalieInterceptIntention";

  globalIntentionDictionary[ DribbleIntention::theId ] =
    "DribbleIntentionIntention";
  globalIntentionDictionary[ PassIntention::theId ] =
    "PassIntention";
  globalIntentionDictionary[ TrivialPassIntention::theId ] =
    "TrivialPassIntention";
  globalIntentionDictionary[ ScoreGoalIntention::theId ] =
    "ScoreGoalIntention";
}
