#ifndef _GOTO_INTENTION_H_
#define _GOTO_INTENTION_H_

#include <vector>
#include "../Intention.h"
#include "../targets/Target.h"
#include "../skills/Skills.h"

class GoToIntention : public Intention{
 public:
  static const IntentionId theId = 4;

  GoToIntention( const Target& aTarget, double maxDesiredPower = globalConf->maxPower,
		 double staminaLimit = globalConf->interceptBallStaminaLimit,
		 const int specialBehaviors = Skills::AVOID_OBSTACLES );


  Action execute();

 private:
  /** Der bisher berechnete Plan. */
  vector<Action> thePlan;
  /** Die gew\"unschte MaximalPower.*/
  double theMaxDesiredPower;
  /** Das Stamina-Limit. */
  double theStaminaLimit;
  /** Spezielles GoToRegion-Verhalten. */
  int theSpecialBehaviour;
  /** das vorherige Ziel */
  Vector thePreviousTargetPos;
  /** das aktuelle Ziel */
  Vector theCurrentTargetPos;

};


#endif
