#include "TurnIntention.h"

#include "../conditions/PlayerDependentConditions.h"
#include "../conditions/PositionConditions.h"
#include "../goalieIntentions/GoalieConditions.h"

#include "../skills/Skills.h"

#include "../../analyzer/Analyzer.h"

TurnIntention::TurnIntention( const Target& aTarget ) :
  BasicIntention( theId, aTarget ) {
  thePreConditions.push_back( new TrueCondition );
  thePostConditions.push_back( new BodyDirectionCondition( aTarget ) );
  hack = NO;
}


// HACK HACK HACK
TurnIntention::TurnIntention() :
  BasicIntention( theId ) {
  thePreConditions.push_back( new TrueCondition );
  theBreakConditions.push_back( new NotCondition( new PositionCondition( Target( Target::GOALIE_STANDARD_POSITION ), 0.20 ) ) );
  thePostConditions.push_back( new GoaliePositionTurnCondition() );
  hack = YES;
}

Action TurnIntention::execute(){
  Vector target( target().pos() );

  INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream
    << idString() << "::execute with target :\n" << target << endl );

  globalSkills->resetSituation( globalWorldModel->situation() );
  
  vector<Action> plan;
  
  if( hack == YES) {
    plan = globalSkills->turnTo( globalAnalyzer->getGoaliePositionTurnVector() );
  }
  else {
    plan = globalSkills->turnTo( target );
  }

  if( plan.size() > 0 ) {
    return plan[0];
  }
  else{
    return Action( EMPTY_ACTION, globalWorldModel->simStep() );
  }
}
