#include "ComplexIntention.h"

#include "../basicIntentions/DummyIntention.h"

ComplexIntention::ComplexIntention( IntentionId aId ) : Intention( aId ) {}

ComplexIntention::ComplexIntention( IntentionId aId, const Target& aTarget ) :
  Intention( aId, aTarget ) {}

ComplexIntention::ComplexIntention( const ComplexIntention& anIntention ) :
  Intention( anIntention ){
  copy( anIntention.theBreakConditions.begin(),	anIntention.theBreakConditions.end(),	theBreakConditions.begin() );
}


ComplexIntention::~ComplexIntention() {
  eraseAllBreakConditions();
}

Action ComplexIntention::execute() {
  INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream <<
	idString() << "::execute\n");

//   bool breakCondRes = (*current)->checkBreakCond();
//   INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream <<
// 	(*current)->idString() <<
// 	"  ::CheckBreak returns : " << breakCondRes << "\n" );

//   // BreakConditions erfuellt?
//   if( breakCondRes ){
//     return (*current)->executeBreak();
//   }

  bool postCondRes =(*current)->checkPostCond();

  INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream <<
	(*current)->idString() <<
	"::checkPost returns : " << postCondRes << "\n" );

  bool preCondRes = (*current)->checkPreCond();
  INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream
	<< (*current)->idString()
	<< "::checkPre returns : " << preCondRes << "\n" );

  if( (!postCondRes ) && preCondRes ) {
    INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream
	  << idString() << "::currentIntention: "
	  <<  (*current)->idString() << "\n" );

    // wenn eine neue Intention eine vorher ausgefhrte ablst
    // wird an der neuen I. Intention::initialize() gerufen
    // diese Routine mu von der Intention redefiniert werden
    // falls sie ntig ist, um ein Rollenspiel zu berechnen
    // Beispiel : FreeKickIntention
     // cerr << idString() << "::currentIntention: " <<  (*current)->idString() <<
     //  "\n" << endl;
    if ( (*current)->id() != lastIntentionId() ) {
      (*current)->initialize();

    }
    // merken, welche Intention zuletzt ausgefhrt wurde
    //lastCurrentIdString = (*current)->idString();
    setLastIntentionId( (*current)->id() );

    // currentIntention.execute() rufen
    INFO( Log::INTENTIONS,  10,  idString() ,
	  globalLog->infoStream << "calling of : "
	  << (*current)->idString()
	  // << " at " << globalTimer-> getAgentTime()
	  << "\n" );
    Action anAction( (*current)->execute() );
    if( anAction.id() != UNDEF_ACTION ){
      return anAction;
    }
    INFO( Log::INTENTIONS,  6,  idString() ,
	  globalLog->infoStream<< "Action ist fehlgeschlagen!!\n" );
    // Action ist fehlgeschlagen
    if( ++current == theIntentions.end() ) {
      current = theIntentions.begin();
      return Action( EMPTY_ACTION, globalWorldModel->simStep() );
    }
    return execute();
  }
  else {
    // die Vor- und Nachbedingung von current waren nicht erfllt
    // einmal durch die Liste durchprfen
    INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream <<
	  idString() << "::checking next \n");
    ++current;
    if  ( current == theIntentions.end() ) {
      // Fallback, Ende der Liste erreicht
      INFO( Log::INTENTIONS,  10,  idString() ,
	    globalLog->infoStream << idString()
	    << ": reached end of IntentionList without succsess \n" );
      // current auf Beginn setzen
      current = theIntentions.begin();

      DummyIntention* dummyIntention = new DummyIntention();
      setLastIntentionId( dummyIntention->id() );
      return dummyIntention->execute();
    }	
    return execute();
  }
}
