#ifndef _EMERGENCY_INTENTION_H_
#define _EMERGENCY_INTENTION_H_

#include "../Intention.h"

#include "ScanFieldIntention.h"
#include "InterceptBallIntention.h"

#include "../basicIntentions/TurnIntention.h"

class EmergencyIntention : public Intention {
 public:
  static const IntentionId theId = 30;

  EmergencyIntention();
  
  Action execute();
  void initialize();
  
 private: 
  void calculateIntentionOrder();
  
  /**@name Die Intentions. */
  //@{
  ///
  ScanFieldIntention *theScanFieldIntention;
  InterceptBallIntention *theInterceptBallIntention;
  TurnIntention* theTurnIntention;
};


extern EmergencyIntention* globalEmergencyIntention;

#endif
