#include "InterceptBallIntention.h"

#include "EmergencyIntention.h"

#include "../basicIntentions/DummyIntention.h"
#include "../basicIntentions/GoToIntention.h"

#include "../conditions/InterceptCondition.h"
#include "../conditions/WorldModelStatesConditions.h"
#include "../conditions/KickConditions.h"
#include "../conditions/ConfidenceCondition.h"
#include "../conditions/PlayerDependentConditions.h"

#include "../../basic/Timer.h"


InterceptBallIntention::InterceptBallIntention( double aDesiredMaxPower ) :
  Intention( theId ), theDesiredMaxPower( aDesiredMaxPower )
{
  addPreCondition( new KickImpossibleCondition() );
  addPreCondition( new InterceptCondition(  InterceptCondition::SMART ) );
  addPreCondition( new GameStateCondition( WorldModelInterface::PLAY_ON ) );
  addPreCondition( new ConfidenceCondition( BALL_ID, 0.5 ) );  // HACK! muss mit dem HACK im Neck konform sein!

/*  addBreakCondition( new GameStateCondition(~( WorldModelInterface::FREE_KICK
                                             | WorldModelInterface::CATCH_BALL_AND_FREE_KICK
                                             | WorldModelInterface::CATCH_BALL) )  );*/

  addPostCondition( new KickPossibleCondition() );
  
  calculateIntentionOrder();
}


void InterceptBallIntention::calculateIntentionOrder() {
  INFO( Log::INTENTIONS  ,  6  ,  idString() , globalLog->infoStream 
    << " ENTER " << idString() << "calculateIntentionOrder::\n" );

  theIntentions.push_back( new GoToIntention( Target( Target::INTERCEPT,
                                              globalWorldModel->id() ),
                                              theDesiredMaxPower,
                                              globalConf->interceptBallStaminaLimit ) );
  current = theIntentions.begin();
}
