#include "ScoreGoalIntention.h"

#include "PassIntention.h"
#include "EmergencyIntention.h"

#include "../basicIntentions/KickIntention.h"
#include "../basicIntentions/DummyIntention.h"

#include "../conditions/KickConditions.h"
#include "../conditions/AttackConditions.h"
#include "../conditions/LostBallCondition.h"

#include "../../basic/Timer.h"

ScoreGoalIntention::ScoreGoalIntention() : Intention( theId ){
  addPreCondition( new KickPossibleCondition() );
  addPreCondition( new GoalReachableCondition() );
  addPreCondition( new ScoreGoalPossibleCondition() );

  addPostCondition( new KickImpossibleCondition() );

  calculateIntentionOrder();
}

ScoreGoalIntention::ScoreGoalIntention( bool risky ) : Intention( theId ){
  addPreCondition( new KickPossibleCondition() );
  addPreCondition( new GoalReachableCondition() );
  addPreCondition( new RiskScoreGoalPossibleCondition() );

  addPostCondition( new KickImpossibleCondition() );

  calculateIntentionOrder();
}

Action ScoreGoalIntention::execute() {
  return Intention::execute();
}


void ScoreGoalIntention::calculateIntentionOrder() {
  theIntentions.push_back( new KickIntention( Target::SCORE_GOAL, globalConf->ballSpeedMax, 3 ) );
  current = theIntentions.begin();
}

