#ifndef _Confidence_CONDITION_H_
#define _Confidence_CONDITION_H_

#include "Condition.h"

#include "../../worldmodel/WorldModelInterface.h"
#include "../../worldmodel/Confidence.h"

class ConfidenceCondition : public Condition{
 public:
  ConfidenceCondition( int aId, double aConfidence = 1.0 );
  
  bool check() const;

 private:
  int theId;
  double theRequestedConfidence;
};

inline bool ConfidenceCondition::check() const{
  INFO( Log::CONDITIONS, 6,  "" , globalLog->infoStream <<
	"ConfidenceCondition::check\n" );
  switch( theId ){
  case BALL_ID:
    return globalWorldModel->ball().posConfidence().reliability()
           >= theRequestedConfidence - DEFAULT_COMPARISON_ACCURACY;
  default:
    return false;
  }
  return false;
}

#endif
