#ifndef _KICK_CONDITIONS_H_
#define _KICK_CONDITIONS_H_

#include "Condition.h"

/** Die KickPossibleCondition pr\"uft, ob ein Kick m\"oglich ist,
    d.h. es wird gepr\"uft, ob der Ball in der Kickrange ist. Es ist
    quasi ein Funktionsobjekt.*/
class KickPossibleCondition : public Condition{
 public:
  KickPossibleCondition();
  
  virtual bool check() const;
};

/** Die KickImPossibleCondition pr\"uft, ob ein Kick nicht m\"oglich ist,
    d.h. es wird gepr\"uft, ob der Ball au\3erhalb der Kickrange ist. Intern wird die
    \Ref{KickPossibleCondition} aufgerufen und deren Ergebnis negiert zur\"uckgegeben. */
class KickImpossibleCondition : public KickPossibleCondition{
 public:
  KickImpossibleCondition();
  bool check() const;
};

inline bool KickImpossibleCondition::check() const{
  INFO( Log::CONDITIONS  ,  6,  "" , globalLog->infoStream <<
	"KickImpossibleCondition::check\n" );
  return !KickPossibleCondition::check();
}

#endif
