#ifndef _NEAREST_CONDITIONS_H_
#define _NEAREST_CONDITIONS_H_

#include "Condition.h"

#include "../targets/Target.h"

#include "../../worldmodel/WorldModelInterface.h"

class NearestPlayerToBallCondition : public Condition{
 public:
  NearestPlayerToBallCondition();

  virtual bool check() const;
};

class NotNearestPlayerToBallCondition : public NearestPlayerToBallCondition{
 public:
  NotNearestPlayerToBallCondition();
  bool check() const;
};

inline bool NotNearestPlayerToBallCondition::check() const{
  return !NearestPlayerToBallCondition::check(); 
}

class NearestPlayerCondition : public Condition{
 public:
  NearestPlayerCondition( const Target& aTarget );

  bool check() const;

 private:
  Target theTarget;
};

#endif
