#ifndef _GOALIE_CONDITIONS_H_
#define _GOALIE_CONDITIONS_H_

#include "../conditions/Condition.h"
#include "../../worldmodel/WorldModelInterface.h"

#include "../roles/StandardGoalieRole.h"


class GoalieInterceptCondition : public Condition {
 public:
  GoalieInterceptCondition(GoalieInterceptBehaviour aBehaviour = StandardGoalieRole::NORMAL);

  void setNeedNewInterceptDecision(bool aBool);
  void setLastInterceptDecision(bool aBool);
  bool check() const;
 private:
  GoalieInterceptBehaviour theBehaviour;

  bool needNewInterceptDecision;
  bool lastInterceptDecision;
};

inline void GoalieInterceptCondition::setNeedNewInterceptDecision(bool aBool) {
  needNewInterceptDecision = aBool;
}

inline void GoalieInterceptCondition::setLastInterceptDecision(bool aBool) {
  lastInterceptDecision = aBool;
}


class CatchCondition : public Condition{
 public:
  CatchCondition();
  bool check() const;
 private:
  bool isBallInCatchableArea() const;
};


/** Die AfterGoalKickCondition soll pr\"ufen, ob der Torwart bereits
    Abstoss gemacht hat. Das ist dann der Fall, wenn
    1. Der Ball weiter als 2m weit weg ist (dann kann von einem
    Schuss ausgegangen werden).
    2. Der Ball gerade erst (vor 2 Takten) vom Goalie freigegeben
    wurde. */
class AfterGoalKickCondition : public Condition{
 public:
  AfterGoalKickCondition();
  bool check() const;
};  

class GoalKickAfterCatchCondition : public Condition{
 public:
  GoalKickAfterCatchCondition();
  bool check() const;
};  


class GoaliePositionTurnCondition : public Condition{
 public:
  GoaliePositionTurnCondition();
  bool check() const;
};

#endif    
