#include "GoalieMoveIntention.h"

#include "../conditions/WorldModelStatesConditions.h"
#include "../conditions/PositionConditions.h"

#include "../../basic/Action.h"
#include "../../worldmodel/WorldModelInterface.h"

GoalieMoveIntention::GoalieMoveIntention( const Target& aTarget ) : Intention( theId, aTarget ) {
    addPreCondition( new GameStateCondition( WorldModelInterface::BEFORE_KICK_OFF | 
                                             WorldModelInterface::GOAL | 
                                             WorldModelInterface::CATCH_BALL_AND_FREE_KICK ) );
	
	addPostCondition( new PositionCondition( aTarget )); //Target::GOALIE_MOVE ));
	//addPostCondition( new PositionCondition( target().pos() ) );
}


Action GoalieMoveIntention::execute() {
  INFO( Log::INTENTIONS,  10,  idString() , globalLog->infoStream << idString() <<	"::execute\n");

  cerr << globalWorldModel->simStep() <<" Move\n";
  Action anAction = Action( MOVE_ACTION, globalWorldModel->simStep(), target().pos().x(), target().pos().y() );
  return anAction;
}
