#include "Common.h" 
#include "Field.h" 
#include "Vector.h" 
#include "StableObject.h" 
 
#include <stream.h> 
 
const int VECTOR_COUNT = 9;  
 
// Test der Feldgroesse 
const Vector vector[] = { 
  Vector( 0, 0 ), 
	Vector( 0, 100 ), 
	Vector( 100, 0 ), 
  Vector( 0, -100 ), 
  Vector( 0, 33.9 ), 
  Vector( 52.4, 0 ), 
  Vector( 52, 33.6 ), 
  Vector( 52.6, 34.1 ), 
  Vector( 52.5, 34.0 )  
};  
 
// Test der ViewPoint-Berechnung innerhalb des Feldes 
const int FACEDIR_TEST_COUNT = 8;  
const StableObject insideLines[ FACEDIR_TEST_COUNT ] = { 
  StableObject( UPPER_LINE_ID, Vector( 10, 60, POLAR, DEGREE ) ), 
  StableObject( UPPER_LINE_ID, Vector( 10, -60, POLAR, DEGREE ) ), 
  StableObject( LOWER_LINE_ID, Vector( 10, 60, POLAR, DEGREE ) ), 
  StableObject( LOWER_LINE_ID, Vector( 10, -60, POLAR, DEGREE ) ), 
  StableObject( LEFT_LINE_ID, Vector( 10, 60, POLAR, DEGREE ) ), 
  StableObject( LEFT_LINE_ID, Vector( 10, -60, POLAR, DEGREE ) ), 
  StableObject( RIGHT_LINE_ID, Vector( 10, 60, POLAR, DEGREE ) ), 
  StableObject( RIGHT_LINE_ID, Vector( 10, -60, POLAR, DEGREE ) ) 
};  
 
const StableObject additionalOutsideLines[ FACEDIR_TEST_COUNT ] = { 
  StableObject( LOWER_LINE_ID, Vector( 10, 60, POLAR, DEGREE ) ), 
  StableObject( LOWER_LINE_ID, Vector( 10, -60, POLAR, DEGREE ) ), 
  StableObject( UPPER_LINE_ID, Vector( 10, 60, POLAR, DEGREE ) ), 
  StableObject( UPPER_LINE_ID, Vector( 10, -60, POLAR, DEGREE ) ), 
  StableObject( RIGHT_LINE_ID, Vector( 10, 60, POLAR, DEGREE ) ), 
  StableObject( RIGHT_LINE_ID, Vector( 10, -60, POLAR, DEGREE ) ), 
  StableObject( LEFT_LINE_ID, Vector( 10, 60, POLAR, DEGREE ) ), 
  StableObject( LEFT_LINE_ID, Vector( 10, -60, POLAR, DEGREE ) ) 
};  
   
   
int main() 
{ 
  globalLog = new Log( 10 );  
  cout << "1. Einfache Funktionen zur Abfrage der Abmessungen:\n" << endl;  
  cout << "Feldlaenge: " << Field::fieldLength() << endl;  
  cout << "Feldbreite: " << Field::fieldWidth() << endl;  
  cout << "Strafraumlaenge: " << Field::penaltyAreaLength() << endl;  
  cout << "Strafraumbreite: " << Field::penaltyAreaWidth() << endl;  
   
  int i;  
  for (i = 0;  i < VECTOR_COUNT;  i++) { 
    cout << "Vektor " << i << ": " << vector[i];  
    cout << ( Field::isInsideField( vector[i] ) ?  
      " im Feld " : " ausserhalb des Feldes" ) << endl;  
  } 
 
  cout << endl << "Berechnung der absoluten Blickrichtung: " << endl;  
  cout << "1. Innerhalb des Feldes:" << endl;  
  Array<StableObject> seenLines;  
  for ( i = 0;  i < FACEDIR_TEST_COUNT;  i++ ) { 
    cout << "Gesehen von innen: " << insideLines[i] << " => Blickwinkel : ";  
    seenLines.removeAll();  
    seenLines.addObject( insideLines[i] );  
    cout << Field::computeFaceDir( seenLines )  * 180 / Ath98_PI << endl;  
  } 
  cout << "2. Ausserhalb des Feldes:" << endl;  
  for ( i = 0;  i < FACEDIR_TEST_COUNT;  i++ ) { 
    cout << "Gesehen von aussen: " << insideLines[i] << " => Blickwinkel : ";  
    seenLines.removeAll();  
    seenLines.addObject( insideLines[i] );  
    seenLines.addObject( additionalOutsideLines[i] );  
    cout << Field::computeFaceDir( seenLines ) * 180 / Ath98_PI << endl;  
  } 
  
  cout << "Fehlt: Test von computePosFromFlag, triangulateViewPoint." << endl;  
  cout << "Dazu PositionAgent nehmen." << endl;  
   
  cout << "\ndone\n";  
  return 0;  
} 
   
;  
