#include <iostream.h>

#include "../basic/Ath98String.h"
#include "../basic/Configuration.h"
#include "../basic/Log.h"
#include "../serverInterface/Message.h"

class MessageTest 
{
 public:  

  void testFunctionality();

  MessageTest();

};

MessageTest::MessageTest() {

}

int main(){
  try {
    globalLog = new Log(10);
    Ath98String serverConfigurationFile = "server.conf";
    Ath98String agentConfigurationFile = "agent.conf";
    
    // Logfile anlegen
    if( !globalLog->isFileReady() ) {
      globalLog->createFiles( 0, "messageTest" );
      INFO( Log::ANY, 0, idString(), globalLog->infoStream <<
            "Logfiles created.\n" );
    }
    globalConf = new Configuration();
    
    globalConf->readConfigurationFile( serverConfigurationFile );
    globalConf->readConfigurationFile( agentConfigurationFile );
    globalLog->init( globalConf );
    globalConf->logCurrentParameterValues();
    
    MessageTest *theMessageTest = new MessageTest();
    theMessageTest->testFunctionality();
  }
  catch( Exception e ) {
    cerr << "Error: " << e.toString() << endl;
    ERROR( e.toString() );
    globalLog->flushInfoStream();
    globalLog->flushStampStream();
    exit( -1 );
  }
  globalLog->flushInfoStream();
  globalLog->flushStampStream();
  return 0;
}


void MessageTest::testFunctionality() {
  INFO( Log::ANY, 2, "", globalLog->infoStream <<
        "Start testing the functionality.\n" );
  Ath98String testString1, testString2;
  long simStep;
  Message::setTeamname( "ABD123" );
  Message message = Message();

  unsigned char out[3];
 
  char buffer[1024];

  simStep = 123;
  INFO(  Log::ANY, 5, "", globalLog->infoStream <<
         "simStep: " << (unsigned short)simStep << endl );
  message.addSimStep( out, simStep );
  message.extractSimStep( out );
  INFO(  Log::ANY, 5, "", globalLog->infoStream <<
         "Zeit: " << message.time() << endl << endl );

  INFO(  Log::ANY, 5, "", globalLog->infoStream <<
         "Teste rufen einer Nachricht\n" );
  testString1 = message.encodeSayMessage( "", 2001 );
  testString1 = message.encodeSayMessage( "Hello alle", 123 );

  INFO(  Log::ANY, 5, "", globalLog->infoStream <<
         "\nTeste empfangen einer Nachricht\n" );
  message.decodeHearMessage( testString1 );
  testString2 = message.message();
  message.decodeHearMessage( "Z9SPewAASGVsbG8gYWxsZSAg" );
  
  cout << "Simstep eingeben: ";
  cin >> simStep;
  cout << "Zu sendende Zeile eingeben: ";
  gets(buffer);
  for(int i=0; i<1024; i++) buffer[i]=(char)(i%64+32);
  buffer[1023]='\0';
  testString1 = message.encodeSayMessage(buffer,simStep);
  message.decodeHearMessage( testString1 );
  testString2 = message.message();  
  cout << endl << "Eingabe: " << buffer << ")" << endl; 
  cout << "Codierte Nachricht: " << testString1 << ")" << endl; 
  cout << "Entschluesselte Nachricht: (" << message.senderInfo() << ", " <<
  message.time() << ", " << message.message() << ")" << endl << endl;
  Message::setTeamname( "ABD123A" );
  message.decodeHearMessage( testString1 );
  cout << "Entschluesselte Nachricht von anderem Team: (" << message.senderInfo() << ", " <<
  message.time() << ", " << message.message() << ")" << endl << endl;
   
}

