#include "Configuration.h" 
#include "Log.h" 
#include "ModelledBall.h" 
#include "ModelledPlayer.h" 
#include "Common.h" 
 
/** 
 * Aktueller Stand 
 * 
 *   $RCSfile: ModelledTest.cc,v $ 
 *   $Revision: 1.1.1.1 $ 
 *   $Date: 2001/07/31 22:23:09 $ 
 *   $Author: rami $  
 * 
 */ 
  
void outputPlayerAndBallData(const ModelledPlayer& aPlayer, 
  const ModelledBall& aBall )  
{ 
  cout << "Winkel des Balls zum Spieler: " <<  
      degFromRadiant( aPlayer.angleTo( aBall.pos() ) ) << 
      " Entfernung: " << aPlayer.distTo( aBall.pos() ) << "\n";  
  cout << "Maximale effektive KickPower: " <<  
      aBall.maxEffectiveKickPower( aPlayer ) << endl;  
  cout << "Effektive KickPower (bei Kick 50): " <<  
      aBall.effectiveKickPower( 50, aPlayer ) << endl;  
  cout << "Benoetigte Power fuer Kick 50): " <<  
      aBall.kickPowerForSend( 50, aPlayer ) << endl << endl;   
} 
 
main() 
{ 
 
  globalLog = new Log(10);  
  globalConf=new Configuration();  
  globalConf->readConfigurationFile("server.conf");  
  globalConf->readConfigurationFile("agent.conf");  
 
  cout << "=========================================================" << endl;  
  cout << "========     ModelledObject / ModelledBall       ========" << endl;  
  cout << "=========================================================" << endl;  
  cout << endl << endl;  
 
  ModelledBall myBall(BALL_ID, Vector(1,1), Vector(0,2), 
      Reliability(0), Reliability(0),1);  
  ModelledBall mB2(BALL_ID, Vector(3,3));  
  ModelledBall mB3;  
  MovingObject myMovObj1(BALL_ID, Vector(1,2), Vector(3,4));  
  ModelledBall mB4(myMovObj1, Reliability(0), Reliability(0), THEIR_TEAM_ID);  
   
  cout << "Die Werte der Klassenvariablen: " << endl;  
  cout << "BallDecay     : " << myBall.decay() << endl;  
  cout << "BallSize      : " << myBall.size() << endl;  
  cout << "BallSpeedMax  : " << myBall.maxSpeed() << endl;  
  cout << "KickMargin    : " << myBall.kickMargin() << endl;  
  cout << "KickPowerRate : " << myBall.kickPowerRate() << endl;  
  cout << myBall.minPower() << " <= Power <= " << myBall.maxPower() << endl;  
  cout << myBall.minMoment() << " <= Moment <= " << myBall.maxMoment() << endl;  
  cout << endl;  
 
  cout << "Test der Konstruktoren" << endl;  
  cout << "----------------------" << endl << endl;  
  cout << "myBall mit Pos(1,1), PosRel 0, Speed(0,2), SpeedRel 0, LTB 1" <<  
      endl << myBall << endl << endl;  
   
  cout << "mB2 mit Pos(3,3)" << endl;  
  cout << mB2 << endl << endl;  
   
  cout << "mB3" << endl;  
  cout << mB3 << endl << endl;  
   
  cout << "mB4 mit dem folgendem MovingObject und ";  
  cout << "PosRel=0, SpeedRel=0, LTB=201" << endl;  
  cout << myMovObj1 << endl;  
  cout << mB4 << endl << endl;  
   
  cout << "Abfragen und aendern von LastTouched by" << endl;  
  cout << "---------------------------------------" << endl << endl;  
   
  cout << "LTB von mB4 abfragen, auf 200 setzen und nochmal abfragen" << endl;  
  cout << mB4.lastTouchedBy() << " , ";  
  mB4.setLastTouchedBy(OUR_TEAM_ID);  
  cout << mB4.lastTouchedBy() << endl << endl;  
 
  cout << "Test der Simulation" << endl;  
  cout << "---------------------------------------" << endl << endl;  
  ModelledBall sim1(BALL_ID, Vector(-41.8959, -16.7589), Vector(5, 2), 
      Reliability(0), Reliability(0), OUR_TEAM_ID);  
  int i=1;  
  cout << "Der folgende Ball wird ueber 10 Schritte simuliert" << endl;  
  cout << "nach 10 Schritten sollte er sich im Punkt (0,0) mit einer " << endl;  
  cout << "Geschwindigkeit von (3.324,1.3297) befinden" << endl;  
  cout << "( bei BallDecay=0.96 ) " << endl;  
  cout << sim1 << endl;  
  while (i<=10){ 
    cout << "Schritt " << i << endl;  
    sim1.simulateSteps();  
    cout << sim1 << endl;  
    i++;  
  } 
  cout << endl;  
   
  ModelledBall sim2(BALL_ID, Vector(-41.8959,-16.7589), Vector(5,2), 
      Reliability(0), Reliability(0), OUR_TEAM_ID);  
   
  cout << "nochmal dasselbe, aber alle 10 Simulationsschritte auf einmal " << 
      "berechen" << endl;  
  cout << "nach 10 Schritten sollte er sich im Punkt (0,0) mit einer " << 
      "Geschwindigkeit von (3.324,1.3297) befinden" << endl;  
  cout << sim2 << endl;  
  cout << "Schritt 10" << endl;  
  sim2.simulateSteps(10);  
  cout << sim2 << endl;  
  cout << endl;  
 
  cout << "Test der KickPower bei verschiedenen Spieler-Positionen" << endl;  
  ModelledBall sim91(BALL_ID, Vector(-5,5));  
  ModelledPlayer Beckenbauer(9,Vector(-5.885,5),Vector(0,0),0);  
 
  outputPlayerAndBallData( Beckenbauer, sim91 );  
   
  Beckenbauer.setPos( Vector( -6.885, 5 ) );  
  outputPlayerAndBallData( Beckenbauer, sim91 );  
  
  Beckenbauer.setPos( Vector( -5, 6.885 ) );  
  outputPlayerAndBallData( Beckenbauer, sim91 );  
  
  Beckenbauer.setPos(Vector(-3.115,5));  
  outputPlayerAndBallData( Beckenbauer, sim91 );  
 
  Beckenbauer.setPos(Vector(-5,5));  
  outputPlayerAndBallData( Beckenbauer, sim91 );  
 
  Beckenbauer.setPos(Vector(-5.4,5));  
  outputPlayerAndBallData( Beckenbauer, sim91 );  
   
  ModelledBall sim3(BALL_ID, Vector(0,0),Vector(0,0));  
  Beckenbauer.setPos(Vector(-0.885,0));  
  Beckenbauer.setFaceDir(0);  
  cout << "Beschleunigungstest" << endl;  
  cout << "1. (Aus dem Stand schiessen) Ball liegt im Punkt (0,0) und " << 
      "wird mit Kraft " << sim3.effectiveKickPower(80,Beckenbauer) << " in ";  
  cout << "Richtung -135 beschleunigt (5 Schritte simuliert;  Spieler " << 
      "am Ball)" << endl;  
  cout << sim3 << endl;  
  cout << "Beschleunigen" << endl;  
  sim3.accelerate(80,radFromDegree(-135),Beckenbauer);  
  i=1;  
  cout << sim3 << endl;   
  while (i<=5){ 
    cout << "Schritt " << i << endl;  
    sim3.simulateSteps();  
    cout << sim3 << endl;  
    i++;  
  } 
  cout << endl;  
 
  ModelledBall sim4(BALL_ID, Vector(0,0),Vector(10,30,POLAR,DEGREE));  
  Beckenbauer.setPos(Vector(-0.885,0));  
  Beckenbauer.setFaceDir(0);  
  cout << "2. (Ball ablenken) Ball ist am  Punkt (0,0) mit Geschwindigkeit " << 
      "(10,30) und wird mit Kraft " ;  
  cout << sim4.effectiveKickPower(100,Beckenbauer) << " in Richtung -10 " << 
      "beschleunigt (5 Schritte simuliert)" << endl;  
  cout << sim4 << endl;  
  cout << "Beschleunigen" << endl;  
  sim4.accelerate(100,radFromDegree(-10),Beckenbauer);  
  i=1;  
  cout << sim4 << endl;   
  while (i<=5){ 
    cout << "Schritt " << i << endl;  
    sim4.simulateSteps();  
    cout << sim4 << endl;  
    i++;  
  } 
  cout << endl;   
 
  ModelledBall sim41(BALL_ID, Vector(0,0), Vector(10, 30, POLAR, DEGREE) );  
  Beckenbauer.setPos(Vector(-1.885,0));  
  Beckenbauer.setFaceDir(0);  
  cout << "2.1. (Ball ablenken) Ball ist am  Punkt (0,0) mit " << 
      "Geschwindigkeit (10,30) und wird mit Kraft " ;  
  cout << sim41.effectiveKickPower(100,Beckenbauer) << " in Richtung " << 
      "-10 beschleunigt (5 Schritte simuliert)" << endl;  
  cout << "Der Spieler steht diesmal etwas weiter weg." << endl;  
  cout << sim41 << endl;  
  cout << "Beschleunigen" << endl;  
  sim41.accelerate(100,radFromDegree(-10),Beckenbauer);  
  i=1;  
  cout << sim41 << endl;   
  while (i<=5){ 
    cout << "Schritt " << i << endl;  
    sim41.simulateSteps();  
    cout << sim41 << endl;  
    i++;  
  } 
  cout << endl;   
   
  ModelledBall sim5(BALL_ID, Vector(0, 0), Vector(1.6, 30, POLAR,DEGREE));  
  Beckenbauer.setPos(Vector(0.885,0));  
  Beckenbauer.setFaceDir(-Ath98_PI);  
  cout << "3. (Ball stoppen) Ball ist am  Punkt (0,0) mit " << 
      "Geschwindigkeit (1.6,30) und wird mit Kraft ";  
  cout << sim5.effectiveKickPower(100,Beckenbauer) << " in " << 
      "Richtung -150 beschleunigt (5 Schritte simuliert)" << endl;  
  cout << sim5 << endl;  
  cout << "Beschleunigen" << endl;  
  sim5.accelerate(100,radFromDegree(-150),Beckenbauer);  
  i=1;  
  cout << sim5 << endl;   
  while (i<=5){ 
    cout << "Schritt " << i << endl;  
    sim5.simulateSteps();  
    cout << sim5 << endl;  
    i++;  
  } 
  cout << endl;   
   
  ModelledBall sim6(BALL_ID, Vector(0, 0), Vector(1.8, 30, POLAR, DEGREE));  
  Beckenbauer.setPos(Vector(-0.885, 0));  
  Beckenbauer.setFaceDir(0);  
  cout << "4. (Ball abwehren) Ball ist am  Punkt (0,0) mit " << 
      "Geschwindigkeit (1.8,30) und wird mit Kraft 100 in Richtung " << 
      "-180 beschleunigt (5 Schritte simuliert)" << endl;  
  cout << sim6 << endl;  
  cout << "Beschleunigen" << endl;  
  sim6.accelerate(100,radFromDegree(-180),Beckenbauer);  
  i=1;  
  cout << sim6 << endl;   
  while (i<=5){ 
    cout << "Schritt " << i << endl;  
    sim6.simulateSteps();  
    cout << sim6 << endl;  
    i++;  
  } 
  cout << endl;   
 
 
  ModelledBall sim7(BALL_ID, Vector(0, 0), Vector(1, 1) );  
  Beckenbauer.setPos(Vector(-0.885,0));  
  Beckenbauer.setFaceDir(0);  
  cout << "Test von ungueltigen Parametern" << endl;  
  cout << sim7 << endl;  
  cout << "zuviel Kraft (500)" << endl;  
  sim7.accelerate(500,0,Beckenbauer);  
  cout << sim7 << endl;  
  sim7.setSpeed(Vector(1,1));  
  cout << "zuwenig Kraft (-100,0)" << endl;  
  sim7.accelerate(-100,0,Beckenbauer);  
  cout << sim7 << endl;  
  sim7.setSpeed(Vector(0,0));  
  cout << sim7 << endl;  
  cout << "Winkel > 180 (750)" << endl;  
  sim7.accelerate(100,750,Beckenbauer);  
  cout << sim7 << endl;  
  cout << endl;   
 
  ModelledBall sim111;  
  cout << "Simulation mit undefinierten Werten" << endl;  
  cout << sim111 << endl;  
  i=1;  
  while (i<=2){ 
    cout << "Schritt " << i << endl;  
    sim111.simulateSteps();  
    cout << sim111 << endl;  
    i++;  
  } 
 
  cout << endl;   
  cout << "=========================================================" << endl;  
  cout << "========            ModelledPlayer               ========" << endl;  
  cout << "=========================================================" <<  
      endl << endl << endl;  
 
  cout << "Test der Konstruktoren" << endl;  
  cout << "-------------------------------------------------------------" <<  
      endl;  
 
  ModelledPlayer Elber( 10, Vector(10,-3), Vector(1,2), 3.12, Reliability(0), 
      Reliability(1), VIEW_WIDTH_NARROW );  
  ModelledPlayer Preetz( 8, Vector(0,1) ), Jancker;  
 
  cout << "1. Spielerangaben ID=10,Pos=(10,-3),Speed=(1,2),faceDir=3.12," << 
      "PosRel=0,SpeedRel=1,Sicht=VIEW_WIDTH_NARROW" << endl;  
  cout << Elber << endl << endl;  
 
  cout << "2. Spielerangaben ID=8,Pos=(0,1)" << endl;  
  cout << Preetz << endl << endl;  
 
  cout << "3. ohne Angaben" << endl;  
  cout << Jancker << endl << endl;  
 
  MovingPlayer seeMoeller(20,Vector(8,8),Vector(1,1),-0.7);  
  ModelledPlayer Haessler(seeMoeller);  
 
  cout << "4. Angaben aus dem folgenden MovingPlayer" << endl;  
  cout << seeMoeller << endl;  
  cout << Haessler << endl << endl;  
 
  cout << "Test des Kraftverbrauchs" << endl;  
  cout << "Es wird jeweils mit der maximal moeglichen und(!) " << 
      "sinnvollen Kraft beschleunigt." << endl;  
  cout << "-------------------------------------------------------------" <<  
      endl;  
 
  i=1;  
  Haessler.setSpeed(Vector(0,0));  
  cout << "Schritt 0" << endl;  
  cout << Haessler << endl << endl;  
  while (i<=55){ 
    cout << "Schritt " << i << ": Beschleunigung mit Kraft ";  
    cout << "( " << Haessler.maxEffectiveDashPower() << " , " <<  
        Haessler.dashPowerForSend(Haessler.maxEffectiveDashPower());  
    cout << " )" << endl;  
    Haessler.accelerate( Haessler.dashPowerForSend( 
        Haessler.maxEffectiveDashPower() ) );  
    Haessler.simulateSteps();  
    cout << Haessler << endl << endl;  
    i++;  
  } 
  cout << "Der Spieler ruht sich 30 Schritte ausaus" << endl << endl;  
  Haessler.simulateSteps(30);  
  i=85;  
  while (i<=90){ 
    cout << "Schritt " << i  << endl;  
    Haessler.simulateSteps();  
    cout << Haessler << endl << endl;  
    i++;  
  } 
  cout << "Der Spieler ruht sich 45 Schritte aus" << endl << endl;  
  Haessler.simulateSteps(45);  
  i=135;  
  while (i<=155){ 
    cout << "Schritt " << i  << endl;  
    Haessler.simulateSteps();  
    cout << Haessler << endl << endl;  
    i++;  
  } 
  cout << endl;  
} 
;  
