 
#include "Common.h" 
#include "Communicator.h"  
#include "Log.h"  
#include "Ath98String.h"  
#include "Sensors.h" 
#include "WorldModel.h" 
#include "Configuration.h" 
 
void buildUp(int argc, char* argv[]);  
void messageLoop();  
void cleanUp();  
 
Communicator* comm;  
Sensors* sense;  
 
int main(int argc, char* argv []) { 
  buildUp(argc, argv);  
 
  messageLoop();  
 
  cleanUp();  
  return 0;  
} 
 
void buildUp(int argc, char* argv[]) { 
  globalLog = new Log(10);  
  globalConf = new Configuration();  
 
  comm = new Communicator( "localhost", 6000 );  
  comm->setLogIsActivated(YES);  
  sense = new Sensors(comm);  
  globalWorldModel = new WorldModel( sense );  
} 
 
void cleanUp() { 
  delete sense;  
  delete comm;  
  delete globalWorldModel;  
  delete globalLog;  
} 
 
void messageLoop() { 
  /* sense->parseSensoryData( "(see 0 ((goal r) 76.7 28) ((flag l t) 15.2 7 -0 0))" );  
  sense->parseSensoryData( "(see 1 ((player hallo 1) 3 0 0 0 0))" );   
  sense->parseSensoryData( "(see 0 ((goal r) 73.7 29) ((flag c t) 12.2 9 -0 0) ((flag r t) 64.7 1) ((flag p r t) 50.4 18) ((flag p r c) 59.7 36) ((flag g r t) 72.2 26) ((flag g r b) 75.9 31) ((flag t 0) 12.4 -14 0 0) ((flag t r 10) 22.2 -7 0 0) ((flag t r 20) 32.1 -5 0 0) ((flag t r 30) 42.1 -4) ((flag t r 40) 51.9 -3) ((flag t r 50) 62.2 -2) ((flag r t 30) 70.1 4) ((flag r t 20) 71.5 12) ((flag r t 10) 74.4 20) ((flag r 0) 78.3 27) ((flag r b 10) 83.1 33) ((flag r b 20) 89.1 38) ((flag r b 30) 95.6 43) ((player hallo 1) 9 0 0 0 0) ((player hallo 2) 6 0 0 0 0) ((player hallo 3) 3 0 0 0 0))" );  
 
  sense->parseSensoryData( "(hear 0 referee kick_off_l)" );  
  sense->parseSensoryData( "(sense_body 17 (view_mode high normal) (stamina 2000 1) (speed 0) (kick 1) (dash 2) (turn 3) (say 4))" );  
 
 
  sense->parseSensoryData( "(see 10 ((goal r) 57.4 0) ((flag c) 5 0 -0 0) ((flag r t) 66.7 -30) ((flag r b) 66.7 30) ((flag p r t) 45.6 -26) ((flag p r c) 40.9 0) ((flag p r b) 45.6 26) ((flag g r t) 57.4 -3) ((flag g r b) 57.4 3) ((flag t r 40) 59.7 -40) ((flag t r 50) 67.4 -35) ((flag b r 40) 59.7 40) ((flag b r 50) 67.4 35) ((flag r t 30) 69.4 -25) ((flag r t 20) 65.4 -17) ((flag r t 10) 63.4 -9) ((flag r 0) 62.8 0) ((flag r b 10) 63.4 9) ((flag r b 20) 65.4 17) ((flag r b 30) 69.4 25) ((ball) 5 0 0 0) ((line r) 57.4 -90))" );  
  */ 
  sense->parseSensoryData( "(see 50 ((goal r) 56.3 0) ((flag c) 3.8 -8 -0.38 -0.9) ((flag c t) 34.8 -83 -0 -0.6) ((flag c b) 33.8 83) ((flag r t) 66 -31) ((flag r b) 65.4 30) ((flag p r t) 44.7 -27) ((flag p r c) 39.6 0) ((flag p r b) 44.3 26) ((flag g r t) 56.8 -7) ((flag g r b) 56.8 6) ((flag t 0) 39.6 -84) ((flag t r 10) 41.7 -70) ((flag t r 20) 46.1 -59) ((flag t r 30) 51.9 -49) ((flag t r 40) 59.1 -42) ((flag t r 50) 66.7 -36) ((flag b 0) 38.5 84) ((flag b r 10) 40.9 70) ((flag b r 20) 45.2 58) ((flag b r 30) 50.9 48) ((flag b r 40) 58 41) ((flag b r 50) 66 35) ((flag r t 30) 68.7 -26) ((flag r t 20) 64.7 -18) ((flag r t 10) 62.2 -9) ((flag r 0) 60.9 0) ((flag r b 10) 62.2 8) ((flag r b 20) 64.1 17) ((flag r b 30) 68 25) ((ball) 3.7 -8 -0.37 -0.9) ((line r) 56.3 -90))" );  
} 
 
 
 
;  
