#include "Confidence.h"
#include "WorldModelInterface.h"

#include "../basic/Configuration.h"
 
/** 
 * Aktueller Stand 
 * 
 *   $RCSfile: Confidence.cc,v $ 
 *   $Revision: 1.1.1.1 $ 
 *   $Date: 2001/07/31 22:23:09 $ 
 *   $Author: rami $  
 * 
 */ 

/**
   Diese Klasse ist noch nicht implementiert:
   Zieldatenstruktur:
   - maxDeviation
   - averageDeviation
   - observationSimstep
 */

Confidence::Confidence() {
  theSimStep = UNDEF_INT; 
  theMaxError = UNDEF_DOUBLE;
  theReliability = 0.0; 
}
 
Confidence::Confidence(const Confidence& aConfidence ) 
{
  theSimStep = aConfidence.simStep(); 
  theMaxError = aConfidence.maxError();
  theReliability = aConfidence.reliability();
} 

Confidence::Confidence( int simStep, double aMaxError, double aReliability )
{
  theSimStep = simStep; 
  theMaxError = aMaxError;
  theReliability = aReliability;
} 

int Confidence::age( ) const {
/*
    if (globalWorldModel->simStep() - theSimStep < 0 ) {
    cerr << " Confidence::ERROR negative age" 
	 << globalWorldModel->simStep() - theSimStep 
	 << "\n";
  }
*/
  // Korrektur bei Spielzustnden, in denen die Zeit steht
  //if ( ! globalWorldModel->isTimeElapsingGameState() ) {
  //  int steps = (int) rint( (globalTimer->getAgentTime() - 
  //		globalWorldModel->startTimeOfElapsingGameState() ) / 100.0);
  //return steps + globalWorldModel->simStep() - theSimStep;
  //}
  return globalWorldModel->simStep() - theSimStep;
}      

ostream& operator<< (ostream& os, const Confidence& confidence )
{
  os << "Confid.:"  << confidence.theSimStep  
     << " " << confidence.theMaxError
     << " " << confidence.theReliability
     << "\n"; 
  return os;
}

Ath98String Confidence::toString() const
{
  Ath98String output;
 
  output = Ath98String( "( SimStep: ") + Ath98String(theSimStep) +
    Ath98String( ", MaxError" ) + Ath98String(theMaxError) +
    Ath98String( ", Reliability: " ) + Ath98String(theReliability) +
    Ath98String( " )" );
  return output;
}
