#include "StableObject.h"

StableObject::StableObject()
  : theId( UNDEF_ID) , thePos( Vector() )
{
  theIdString = "StableObject";
}

StableObject::StableObject( int anId, const Vector& aPoint )
  : theId( anId ), thePos( aPoint )
{
  theIdString = "StableObject";
}

StableObject::~StableObject() {
}

// Das kann keine Inline-Funktion sein, weil sie Ath98String-Methoden einsetzt,
// und auch Ath98String ein StableObject ist.
void StableObject::printOn (ostream& anOutputStream ) const
{
  anOutputStream << toString().cString();
}

void StableObject::toInfoStream(ostream& os) const
{
  os << "StableObject \n";
}


StableObject* StableObject::copy() const {
  return new StableObject( *this );
}

Ath98String StableObject::toString() const
{
  Ath98String output;
  output = Ath98String( "( id: " ) + Ath98String( id() ) + Ath98String(", position: ") +
    pos().toString() + Ath98String( " )" );
  return output;
}
