#ifndef _WORLDMODELCOMMUNICATOR_H_
#define _WORLDMODELCOMMUNICATOR_H_

#include "../basic/Ath98String.h"
#include "WorldModelCommunicator.h"

class Situation;
class WorldModelCore;

class WorldModelCommunicator 
{

 public:
 
  WorldModelCommunicator( );

  void setWorldModelReference( WorldModelCore* aWorldModelCore  );  

  Ath98String saySituation(const Situation& situation);
  
  int understandYourSituation(Situation& situation, const char* message);


 private:
 
  WorldModelCore* theCore;

  void writeBitStringForDebug(char *bitstring, int bytes);

  int getByteFromBitstring(const char *bitstring, const int offset);

  int getCharFromBitstring(const char *bitstring, const int offset);

  int writeIntToBitstring(int value, const int bits, const int bottom, const int top, char *bitstring, const int offset);

  int readIntFromBitstring(const int bits, const int bottom, const int top, const char *bitstring, const int offset);

  int writeDoubleToBitstring(double value, const int bits, const double bottom, const double top, char *bitstring, const int offset);

  double readDoubleFromBitstring(const int bits, const double bottom, const double top, const char *bitstring, int offset);

  int generateSayMessage(char *message, const char *bitstring, const int bits);
  
  int generateBitstring(char *bitstring, const char *message);
  
  int calculateChecksum(char *bitstring, int bits);

};

#endif
