/**
 * Aktueller Stand
 *
 *   $RCSfile: WorldModelInterface.cc,v $
 *   $Revision: 1.1.1.1 $
 *   $Date: 2001/07/31 22:23:09 $
 *   $Author: rami $
 *
 */

#include "WorldModelCore.h"
#include "WorldModelInterface.h"


WorldModelInterface *globalWorldModel;  
 
WorldModelInterface::WorldModelInterface( Sensors * theSensors)
{ 
  theWorldModelCore = new WorldModelCore( theSensors);
  theWorldModelCore->initializeCore();
} 
  
void WorldModelInterface::integrateSensorInfo() 
{ 
  theWorldModelCore->integrateSensorInfo(); 
}

void WorldModelInterface::integrateCorrectSensorInfo() 
{ 
  theWorldModelCore->integrateCorrectSensorInfo(); 
}



void WorldModelInterface::registerExecution( const Action& anAction )  
{ 
  theWorldModelCore->registerExecution( anAction );
}   


const ModelledPlayer& WorldModelInterface::player( int playerId ) const 
{ 
  return theWorldModelCore->player( playerId );
} 

void WorldModelInterface::setPlayerNumber( int newPlayerNumber, bool isGoalie ) 
{ 
  theWorldModelCore->setPlayerNumber( newPlayerNumber, isGoalie );
}

 
const ModelledBall& WorldModelInterface::ball() const 
{ 
  return theWorldModelCore->ball( ) ;  
} 
 
const Situation& WorldModelInterface::situation( int timeStepOffset = 0 ) const 
{ 
  return theWorldModelCore->situation( timeStepOffset );
} 

const Situation& WorldModelInterface::correctSituation( ) const 
{ 
  return theWorldModelCore->correctSituation( );
} 

bool WorldModelInterface::hasInitiative( int aTeamId ) const 
{ 
  return theWorldModelCore->hasInitiative( aTeamId );
} 

void WorldModelInterface::setGameState( int newGameState ) 
{ 
  theWorldModelCore->setGameState( newGameState ); 
} 

void WorldModelInterface::setInitiative( int newInitiative )  
{ 
  theWorldModelCore->setInitiative( newInitiative );
}

Vector WorldModelInterface::preferredKickDirection( const Vector& pos ) const
{ 
  return theWorldModelCore->preferredKickDirection( pos );
} 

Vector WorldModelInterface::backKickDirection( const Vector& pos ) const 
{ 
   return theWorldModelCore->backKickDirection( pos );
} 

RegionOnField WorldModelInterface::region( const Vector& pos ) const
{
   return theWorldModelCore->region( pos );	
}	


int WorldModelInterface::simStepOfSee() const 
{
  return theWorldModelCore->simStepOfSee();
}
 

  int WorldModelInterface::playerNumber() const 
{
  return theWorldModelCore->playerNumber();
}

const Ath98String& WorldModelInterface::teamName() const
{
  return theWorldModelCore->teamName();
}

int WorldModelInterface::side() const 
{
  return theWorldModelCore->side();
} 

int WorldModelInterface::role() const 
{ 
  return theWorldModelCore->role();   
}
 
int WorldModelInterface::id() const
{
  return  theWorldModelCore->id();
}

Vector WorldModelInterface::basePosition( int aGameState, int anInitiative ) const
{
  return  theWorldModelCore->basePosition( aGameState, anInitiative );
}

Vector WorldModelInterface::initialPosition( int aGameState, 
					     int anInitiative ) const
{
  return theWorldModelCore->initialPosition( aGameState, 
			       anInitiative );
}

  int WorldModelInterface::simStep() const 
{
  return theWorldModelCore->simStep(); 
}

  int WorldModelInterface::initiative() const
{
  return theWorldModelCore->initiative(); 
}

  int WorldModelInterface::gameState() const
{
  return theWorldModelCore->gameState(); 
}

  int WorldModelInterface::score( int aTeamId ) const
{ 
  return theWorldModelCore->score( aTeamId );
} 

  const Field& WorldModelInterface::field() const
{
  return theWorldModelCore->field(); 
}

  int WorldModelInterface::simStepOfLastCatch() const
{
  return theWorldModelCore->simStepOfLastCatch(); 
}

  int WorldModelInterface::simStepWhenCatchedBallIsReleased() const
{
  return theWorldModelCore->simStepWhenCatchedBallIsReleased(); 
}

  int WorldModelInterface::simStepOfLastSay() const
{
  return theWorldModelCore->simStepOfLastSay();  
}

  int WorldModelInterface::simStepOfLastRefereeDecision() const
{
  return theWorldModelCore->simStepOfLastRefereeDecision(); 
}

  int WorldModelInterface::simStepOfLastFreekick() const
{
  return theWorldModelCore->simStepOfLastFreekick(); 
}

  int WorldModelInterface::simStepOfLastSee() const{
  return theWorldModelCore->simStepOfLastSee();
}


  bool WorldModelInterface::isTimeElapsingGameState()
{
  return theWorldModelCore->isTimeElapsingGameState(); 
}


int WorldModelInterface::startTimeOfElapsingGameState() const
{
  return  theWorldModelCore->startTimeOfElapsingGameState();
}



  void WorldModelInterface::setTeamName( const Ath98String& newTeamName )
{
   theWorldModelCore->setTeamName(newTeamName);
}

  void WorldModelInterface::setSide( int newSide ) 
{
  theWorldModelCore->setSide(newSide);
}

  void WorldModelInterface::setRole( int newRole ) 
{ 
  theWorldModelCore->setRole(newRole);  
}

  void WorldModelInterface::setSimStep( int newValue )
{
  theWorldModelCore->setSimStep(newValue );
}

  void WorldModelInterface::setScore(int newScore, int aTeamId )
{ 
  theWorldModelCore->setScore( newScore, aTeamId );
} 



void WorldModelInterface::setBasePosition(  
	int aGameState, int anInitiative, const Vector& pos ) 
{ 
  theWorldModelCore->setBasePosition( aGameState, anInitiative, pos );  
} 

  bool WorldModelInterface::goalieCanMove() const{
  return theWorldModelCore->goalieCanMove(); 
}

  void WorldModelInterface::setCanGoalieMove( bool hasMoved ){
  theWorldModelCore->setCanGoalieMove(hasMoved);
}

Ath98String WorldModelInterface::saySituation( const Situation& aSituation ) {
    return theWorldModelCore->saySituation( aSituation );
}

string WorldModelInterface::idString() const{
    return theWorldModelCore->idString();
}

ostream& operator<< (ostream& os, const WorldModelInterface& worldmodel){
  os << *(worldmodel.theWorldModelCore); 
  return os;
}

int WorldModelInterface::simStepOfLastMichaelsError() {
  return theWorldModelCore->simStepOfLastMichaelsError;
}


int WorldModelInterface::getAgentTimeOfLastSeeInfo() {
	return theWorldModelCore->getAgentTimeOfLastSeeInfo();
}

